// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:action/CameraDeleteFileByIndex.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__STRUCT_H_
#define PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_Goal
{
  /// see enum E_DjiMountPosition in dji_typedef.h
  uint8_t payload_index;
  uint32_t file_index;
} psdk_interfaces__action__CameraDeleteFileByIndex_Goal;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_Goal.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence;


// Constants defined in the message

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_Result
{
  bool success;
} psdk_interfaces__action__CameraDeleteFileByIndex_Result;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_Result.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence;


// Constants defined in the message

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_Feedback
{
  uint8_t structure_needs_at_least_one_member;
} psdk_interfaces__action__CameraDeleteFileByIndex_Feedback;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_Feedback.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.h"

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal goal;
} psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.h"

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response
{
  int8_t status;
  psdk_interfaces__action__CameraDeleteFileByIndex_Result result;
} psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.h"

/// Struct defined in action/CameraDeleteFileByIndex in the package psdk_interfaces.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback feedback;
} psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage;

// Struct for a sequence of psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage.
typedef struct psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence
{
  psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__STRUCT_H_
