// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/DisplayMode.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__DISPLAY_MODE__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__DISPLAY_MODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__DisplayMode __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__DisplayMode __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DisplayMode_
{
  using Type = DisplayMode_<ContainerAllocator>;

  explicit DisplayMode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->display_mode = 0;
    }
  }

  explicit DisplayMode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->display_mode = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _display_mode_type =
    uint8_t;
  _display_mode_type display_mode;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__display_mode(
    const uint8_t & _arg)
  {
    this->display_mode = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t DISPLAY_MODE_MANUAL_CTRL =
    0u;
  static constexpr uint8_t DISPLAY_MODE_ATTITUDE =
    1u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_2 =
    2u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_3 =
    3u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_4 =
    4u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_5 =
    5u;
  static constexpr uint8_t DISPLAY_MODE_P_GPS =
    6u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_7 =
    7u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_8 =
    8u;
  static constexpr uint8_t DISPLAY_MODE_HOTPOINT_MODE =
    9u;
  static constexpr uint8_t DISPLAY_MODE_ASSISTED_TAKEOFF =
    10u;
  static constexpr uint8_t DISPLAY_MODE_AUTO_TAKEOFF =
    11u;
  static constexpr uint8_t DISPLAY_MODE_AUTO_LANDING =
    12u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_13 =
    13u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_14 =
    14u;
  static constexpr uint8_t DISPLAY_MODE_NAVI_GO_HOME =
    15u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_16 =
    16u;
  static constexpr uint8_t DISPLAY_MODE_NAVI_SDK_CTRL =
    17u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_18 =
    18u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_19 =
    19u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_20 =
    20u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_21 =
    21u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_22 =
    22u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_23 =
    23u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_24 =
    24u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_25 =
    25u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_26 =
    26u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_27 =
    27u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_28 =
    28u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_29 =
    29u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_30 =
    30u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_31 =
    31u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_32 =
    32u;
  static constexpr uint8_t DISPLAY_MODE_FORCE_AUTO_LANDING =
    33u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_34 =
    34u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_35 =
    35u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_36 =
    36u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_37 =
    37u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_38 =
    38u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_39 =
    39u;
  static constexpr uint8_t DISPLAY_MODE_SEARCH_MODE =
    40u;
  static constexpr uint8_t DISPLAY_MODE_ENGINE_START =
    41u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_42 =
    42u;
  static constexpr uint8_t DISPLAY_MODE_RESERVED_43 =
    42u;

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::DisplayMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::DisplayMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::DisplayMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::DisplayMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__DisplayMode
    std::shared_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__DisplayMode
    std::shared_ptr<psdk_interfaces::msg::DisplayMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DisplayMode_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->display_mode != other.display_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const DisplayMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DisplayMode_

// alias to use template instance with default allocator
using DisplayMode =
  psdk_interfaces::msg::DisplayMode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_MANUAL_CTRL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_ATTITUDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_P_GPS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_7;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_8;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_HOTPOINT_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_ASSISTED_TAKEOFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_AUTO_TAKEOFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_AUTO_LANDING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_13;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_14;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_NAVI_GO_HOME;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_16;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_NAVI_SDK_CTRL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_18;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_19;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_20;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_21;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_22;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_23;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_24;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_25;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_26;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_27;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_28;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_29;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_30;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_31;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_32;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_FORCE_AUTO_LANDING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_34;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_35;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_36;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_37;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_38;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_39;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_SEARCH_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_ENGINE_START;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_42;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DisplayMode_<ContainerAllocator>::DISPLAY_MODE_RESERVED_43;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__DISPLAY_MODE__STRUCT_HPP_
