// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/EscData.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/esc_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `esc`
#include "psdk_interfaces/msg/detail/esc_status_individual__functions.h"

bool
psdk_interfaces__msg__EscData__init(psdk_interfaces__msg__EscData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__EscData__fini(msg);
    return false;
  }
  // esc
  if (!psdk_interfaces__msg__EscStatusIndividual__Sequence__init(&msg->esc, 0)) {
    psdk_interfaces__msg__EscData__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__msg__EscData__fini(psdk_interfaces__msg__EscData * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // esc
  psdk_interfaces__msg__EscStatusIndividual__Sequence__fini(&msg->esc);
}

bool
psdk_interfaces__msg__EscData__are_equal(const psdk_interfaces__msg__EscData * lhs, const psdk_interfaces__msg__EscData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // esc
  if (!psdk_interfaces__msg__EscStatusIndividual__Sequence__are_equal(
      &(lhs->esc), &(rhs->esc)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__EscData__copy(
  const psdk_interfaces__msg__EscData * input,
  psdk_interfaces__msg__EscData * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // esc
  if (!psdk_interfaces__msg__EscStatusIndividual__Sequence__copy(
      &(input->esc), &(output->esc)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__msg__EscData *
psdk_interfaces__msg__EscData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__EscData * msg = (psdk_interfaces__msg__EscData *)allocator.allocate(sizeof(psdk_interfaces__msg__EscData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__EscData));
  bool success = psdk_interfaces__msg__EscData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__EscData__destroy(psdk_interfaces__msg__EscData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__EscData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__EscData__Sequence__init(psdk_interfaces__msg__EscData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__EscData * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__EscData *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__EscData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__EscData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__EscData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__EscData__Sequence__fini(psdk_interfaces__msg__EscData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__EscData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__EscData__Sequence *
psdk_interfaces__msg__EscData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__EscData__Sequence * array = (psdk_interfaces__msg__EscData__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__EscData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__EscData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__EscData__Sequence__destroy(psdk_interfaces__msg__EscData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__EscData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__EscData__Sequence__are_equal(const psdk_interfaces__msg__EscData__Sequence * lhs, const psdk_interfaces__msg__EscData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__EscData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__EscData__Sequence__copy(
  const psdk_interfaces__msg__EscData__Sequence * input,
  psdk_interfaces__msg__EscData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__EscData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__EscData * data =
      (psdk_interfaces__msg__EscData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__EscData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__EscData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__EscData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
