// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/EscStatusIndividual.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/esc_status_individual__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
psdk_interfaces__msg__EscStatusIndividual__init(psdk_interfaces__msg__EscStatusIndividual * msg)
{
  if (!msg) {
    return false;
  }
  // current
  // speed
  // voltage
  // temperature
  // stall
  // empty
  // unbalanced
  // esc_disconnected
  // temperature_high
  return true;
}

void
psdk_interfaces__msg__EscStatusIndividual__fini(psdk_interfaces__msg__EscStatusIndividual * msg)
{
  if (!msg) {
    return;
  }
  // current
  // speed
  // voltage
  // temperature
  // stall
  // empty
  // unbalanced
  // esc_disconnected
  // temperature_high
}

bool
psdk_interfaces__msg__EscStatusIndividual__are_equal(const psdk_interfaces__msg__EscStatusIndividual * lhs, const psdk_interfaces__msg__EscStatusIndividual * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // speed
  if (lhs->speed != rhs->speed) {
    return false;
  }
  // voltage
  if (lhs->voltage != rhs->voltage) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  // stall
  if (lhs->stall != rhs->stall) {
    return false;
  }
  // empty
  if (lhs->empty != rhs->empty) {
    return false;
  }
  // unbalanced
  if (lhs->unbalanced != rhs->unbalanced) {
    return false;
  }
  // esc_disconnected
  if (lhs->esc_disconnected != rhs->esc_disconnected) {
    return false;
  }
  // temperature_high
  if (lhs->temperature_high != rhs->temperature_high) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__EscStatusIndividual__copy(
  const psdk_interfaces__msg__EscStatusIndividual * input,
  psdk_interfaces__msg__EscStatusIndividual * output)
{
  if (!input || !output) {
    return false;
  }
  // current
  output->current = input->current;
  // speed
  output->speed = input->speed;
  // voltage
  output->voltage = input->voltage;
  // temperature
  output->temperature = input->temperature;
  // stall
  output->stall = input->stall;
  // empty
  output->empty = input->empty;
  // unbalanced
  output->unbalanced = input->unbalanced;
  // esc_disconnected
  output->esc_disconnected = input->esc_disconnected;
  // temperature_high
  output->temperature_high = input->temperature_high;
  return true;
}

psdk_interfaces__msg__EscStatusIndividual *
psdk_interfaces__msg__EscStatusIndividual__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__EscStatusIndividual * msg = (psdk_interfaces__msg__EscStatusIndividual *)allocator.allocate(sizeof(psdk_interfaces__msg__EscStatusIndividual), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__EscStatusIndividual));
  bool success = psdk_interfaces__msg__EscStatusIndividual__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__EscStatusIndividual__destroy(psdk_interfaces__msg__EscStatusIndividual * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__EscStatusIndividual__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__EscStatusIndividual__Sequence__init(psdk_interfaces__msg__EscStatusIndividual__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__EscStatusIndividual * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__EscStatusIndividual *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__EscStatusIndividual), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__EscStatusIndividual__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__EscStatusIndividual__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__EscStatusIndividual__Sequence__fini(psdk_interfaces__msg__EscStatusIndividual__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__EscStatusIndividual__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__EscStatusIndividual__Sequence *
psdk_interfaces__msg__EscStatusIndividual__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__EscStatusIndividual__Sequence * array = (psdk_interfaces__msg__EscStatusIndividual__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__EscStatusIndividual__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__EscStatusIndividual__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__EscStatusIndividual__Sequence__destroy(psdk_interfaces__msg__EscStatusIndividual__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__EscStatusIndividual__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__EscStatusIndividual__Sequence__are_equal(const psdk_interfaces__msg__EscStatusIndividual__Sequence * lhs, const psdk_interfaces__msg__EscStatusIndividual__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__EscStatusIndividual__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__EscStatusIndividual__Sequence__copy(
  const psdk_interfaces__msg__EscStatusIndividual__Sequence * input,
  psdk_interfaces__msg__EscStatusIndividual__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__EscStatusIndividual);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__EscStatusIndividual * data =
      (psdk_interfaces__msg__EscStatusIndividual *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__EscStatusIndividual__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__EscStatusIndividual__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__EscStatusIndividual__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
