// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/EscStatusIndividual.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/EscStatusIndividual in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__EscStatusIndividual
{
  /// ESC current, unit: mA
  int16_t current;
  /// ESC speed, unit: rpm
  int16_t speed;
  /// Input power from battery to ESC, unit: mV
  uint16_t voltage;
  /// ESC temperature, unit: degree C
  int16_t temperature;
  /// Motor is stall
  int16_t stall;
  /// Motor has no load
  int16_t empty;
  /// Motor speed is unbalanced
  int16_t unbalanced;
  /// ESC is disconnected
  int16_t esc_disconnected;
  /// Temperature is high
  int16_t temperature_high;
} psdk_interfaces__msg__EscStatusIndividual;

// Struct for a sequence of psdk_interfaces__msg__EscStatusIndividual.
typedef struct psdk_interfaces__msg__EscStatusIndividual__Sequence
{
  psdk_interfaces__msg__EscStatusIndividual * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__EscStatusIndividual__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__STRUCT_H_
