// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/EscStatusIndividual.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__EscStatusIndividual __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__EscStatusIndividual __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EscStatusIndividual_
{
  using Type = EscStatusIndividual_<ContainerAllocator>;

  explicit EscStatusIndividual_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->current = 0;
      this->speed = 0;
      this->voltage = 0;
      this->temperature = 0;
      this->stall = 0;
      this->empty = 0;
      this->unbalanced = 0;
      this->esc_disconnected = 0;
      this->temperature_high = 0;
    }
  }

  explicit EscStatusIndividual_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->current = 0;
      this->speed = 0;
      this->voltage = 0;
      this->temperature = 0;
      this->stall = 0;
      this->empty = 0;
      this->unbalanced = 0;
      this->esc_disconnected = 0;
      this->temperature_high = 0;
    }
  }

  // field types and members
  using _current_type =
    int16_t;
  _current_type current;
  using _speed_type =
    int16_t;
  _speed_type speed;
  using _voltage_type =
    uint16_t;
  _voltage_type voltage;
  using _temperature_type =
    int16_t;
  _temperature_type temperature;
  using _stall_type =
    int16_t;
  _stall_type stall;
  using _empty_type =
    int16_t;
  _empty_type empty;
  using _unbalanced_type =
    int16_t;
  _unbalanced_type unbalanced;
  using _esc_disconnected_type =
    int16_t;
  _esc_disconnected_type esc_disconnected;
  using _temperature_high_type =
    int16_t;
  _temperature_high_type temperature_high;

  // setters for named parameter idiom
  Type & set__current(
    const int16_t & _arg)
  {
    this->current = _arg;
    return *this;
  }
  Type & set__speed(
    const int16_t & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__voltage(
    const uint16_t & _arg)
  {
    this->voltage = _arg;
    return *this;
  }
  Type & set__temperature(
    const int16_t & _arg)
  {
    this->temperature = _arg;
    return *this;
  }
  Type & set__stall(
    const int16_t & _arg)
  {
    this->stall = _arg;
    return *this;
  }
  Type & set__empty(
    const int16_t & _arg)
  {
    this->empty = _arg;
    return *this;
  }
  Type & set__unbalanced(
    const int16_t & _arg)
  {
    this->unbalanced = _arg;
    return *this;
  }
  Type & set__esc_disconnected(
    const int16_t & _arg)
  {
    this->esc_disconnected = _arg;
    return *this;
  }
  Type & set__temperature_high(
    const int16_t & _arg)
  {
    this->temperature_high = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__EscStatusIndividual
    std::shared_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__EscStatusIndividual
    std::shared_ptr<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EscStatusIndividual_ & other) const
  {
    if (this->current != other.current) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->voltage != other.voltage) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    if (this->stall != other.stall) {
      return false;
    }
    if (this->empty != other.empty) {
      return false;
    }
    if (this->unbalanced != other.unbalanced) {
      return false;
    }
    if (this->esc_disconnected != other.esc_disconnected) {
      return false;
    }
    if (this->temperature_high != other.temperature_high) {
      return false;
    }
    return true;
  }
  bool operator!=(const EscStatusIndividual_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EscStatusIndividual_

// alias to use template instance with default allocator
using EscStatusIndividual =
  psdk_interfaces::msg::EscStatusIndividual_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__STRUCT_HPP_
