// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/EscStatusIndividual.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/esc_status_individual__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const EscStatusIndividual & msg,
  std::ostream & out)
{
  out << "{";
  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    rosidl_generator_traits::value_to_yaml(msg.speed, out);
    out << ", ";
  }

  // member: voltage
  {
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << ", ";
  }

  // member: temperature
  {
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << ", ";
  }

  // member: stall
  {
    out << "stall: ";
    rosidl_generator_traits::value_to_yaml(msg.stall, out);
    out << ", ";
  }

  // member: empty
  {
    out << "empty: ";
    rosidl_generator_traits::value_to_yaml(msg.empty, out);
    out << ", ";
  }

  // member: unbalanced
  {
    out << "unbalanced: ";
    rosidl_generator_traits::value_to_yaml(msg.unbalanced, out);
    out << ", ";
  }

  // member: esc_disconnected
  {
    out << "esc_disconnected: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_disconnected, out);
    out << ", ";
  }

  // member: temperature_high
  {
    out << "temperature_high: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature_high, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EscStatusIndividual & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed: ";
    rosidl_generator_traits::value_to_yaml(msg.speed, out);
    out << "\n";
  }

  // member: voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << "\n";
  }

  // member: temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << "\n";
  }

  // member: stall
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stall: ";
    rosidl_generator_traits::value_to_yaml(msg.stall, out);
    out << "\n";
  }

  // member: empty
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "empty: ";
    rosidl_generator_traits::value_to_yaml(msg.empty, out);
    out << "\n";
  }

  // member: unbalanced
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "unbalanced: ";
    rosidl_generator_traits::value_to_yaml(msg.unbalanced, out);
    out << "\n";
  }

  // member: esc_disconnected
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "esc_disconnected: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_disconnected, out);
    out << "\n";
  }

  // member: temperature_high
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature_high: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature_high, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EscStatusIndividual & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::EscStatusIndividual & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::EscStatusIndividual & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::EscStatusIndividual>()
{
  return "psdk_interfaces::msg::EscStatusIndividual";
}

template<>
inline const char * name<psdk_interfaces::msg::EscStatusIndividual>()
{
  return "psdk_interfaces/msg/EscStatusIndividual";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::EscStatusIndividual>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::EscStatusIndividual>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::msg::EscStatusIndividual>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__ESC_STATUS_INDIVIDUAL__TRAITS_HPP_
