// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/FileAttributes.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FILE_ATTRIBUTES__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FILE_ATTRIBUTES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__FileAttributes __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__FileAttributes __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FileAttributes_
{
  using Type = FileAttributes_<ContainerAllocator>;

  explicit FileAttributes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->photo_ratio = 0ul;
      this->photo_rotation = 0ul;
      this->video_duration = 0ul;
      this->video_frame_rate = 0ul;
      this->video_rotation = 0ul;
      this->video_resolution = 0ul;
    }
  }

  explicit FileAttributes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->photo_ratio = 0ul;
      this->photo_rotation = 0ul;
      this->video_duration = 0ul;
      this->video_frame_rate = 0ul;
      this->video_rotation = 0ul;
      this->video_resolution = 0ul;
    }
  }

  // field types and members
  using _photo_ratio_type =
    uint32_t;
  _photo_ratio_type photo_ratio;
  using _photo_rotation_type =
    uint32_t;
  _photo_rotation_type photo_rotation;
  using _video_duration_type =
    uint32_t;
  _video_duration_type video_duration;
  using _video_frame_rate_type =
    uint32_t;
  _video_frame_rate_type video_frame_rate;
  using _video_rotation_type =
    uint32_t;
  _video_rotation_type video_rotation;
  using _video_resolution_type =
    uint32_t;
  _video_resolution_type video_resolution;

  // setters for named parameter idiom
  Type & set__photo_ratio(
    const uint32_t & _arg)
  {
    this->photo_ratio = _arg;
    return *this;
  }
  Type & set__photo_rotation(
    const uint32_t & _arg)
  {
    this->photo_rotation = _arg;
    return *this;
  }
  Type & set__video_duration(
    const uint32_t & _arg)
  {
    this->video_duration = _arg;
    return *this;
  }
  Type & set__video_frame_rate(
    const uint32_t & _arg)
  {
    this->video_frame_rate = _arg;
    return *this;
  }
  Type & set__video_rotation(
    const uint32_t & _arg)
  {
    this->video_rotation = _arg;
    return *this;
  }
  Type & set__video_resolution(
    const uint32_t & _arg)
  {
    this->video_resolution = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::FileAttributes_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::FileAttributes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FileAttributes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FileAttributes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__FileAttributes
    std::shared_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__FileAttributes
    std::shared_ptr<psdk_interfaces::msg::FileAttributes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FileAttributes_ & other) const
  {
    if (this->photo_ratio != other.photo_ratio) {
      return false;
    }
    if (this->photo_rotation != other.photo_rotation) {
      return false;
    }
    if (this->video_duration != other.video_duration) {
      return false;
    }
    if (this->video_frame_rate != other.video_frame_rate) {
      return false;
    }
    if (this->video_rotation != other.video_rotation) {
      return false;
    }
    if (this->video_resolution != other.video_resolution) {
      return false;
    }
    return true;
  }
  bool operator!=(const FileAttributes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FileAttributes_

// alias to use template instance with default allocator
using FileAttributes =
  psdk_interfaces::msg::FileAttributes_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__FILE_ATTRIBUTES__STRUCT_HPP_
