// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from psdk_interfaces:msg/FileInfo.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "psdk_interfaces/msg/detail/file_info__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace psdk_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void FileInfo_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) psdk_interfaces::msg::FileInfo(_init);
}

void FileInfo_fini_function(void * message_memory)
{
  auto typed_message = static_cast<psdk_interfaces::msg::FileInfo *>(message_memory);
  typed_message->~FileInfo();
}

size_t size_function__FileInfo__sub_files(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<psdk_interfaces::msg::SubFileInfo> *>(untyped_member);
  return member->size();
}

const void * get_const_function__FileInfo__sub_files(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<psdk_interfaces::msg::SubFileInfo> *>(untyped_member);
  return &member[index];
}

void * get_function__FileInfo__sub_files(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<psdk_interfaces::msg::SubFileInfo> *>(untyped_member);
  return &member[index];
}

void fetch_function__FileInfo__sub_files(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const psdk_interfaces::msg::SubFileInfo *>(
    get_const_function__FileInfo__sub_files(untyped_member, index));
  auto & value = *reinterpret_cast<psdk_interfaces::msg::SubFileInfo *>(untyped_value);
  value = item;
}

void assign_function__FileInfo__sub_files(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<psdk_interfaces::msg::SubFileInfo *>(
    get_function__FileInfo__sub_files(untyped_member, index));
  const auto & value = *reinterpret_cast<const psdk_interfaces::msg::SubFileInfo *>(untyped_value);
  item = value;
}

void resize_function__FileInfo__sub_files(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<psdk_interfaces::msg::SubFileInfo> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember FileInfo_message_member_array[8] = {
  {
    "name",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, name),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "size",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT32,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, size),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "index",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT32,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, index),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "create_time_unix",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, create_time_unix),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "attributes",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<psdk_interfaces::msg::FileAttributes>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, attributes),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "number_sub_files",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, number_sub_files),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "sub_files",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<psdk_interfaces::msg::SubFileInfo>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(psdk_interfaces::msg::FileInfo, sub_files),  // bytes offset in struct
    nullptr,  // default value
    size_function__FileInfo__sub_files,  // size() function pointer
    get_const_function__FileInfo__sub_files,  // get_const(index) function pointer
    get_function__FileInfo__sub_files,  // get(index) function pointer
    fetch_function__FileInfo__sub_files,  // fetch(index, &value) function pointer
    assign_function__FileInfo__sub_files,  // assign(index, value) function pointer
    resize_function__FileInfo__sub_files  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers FileInfo_message_members = {
  "psdk_interfaces::msg",  // message namespace
  "FileInfo",  // message name
  8,  // number of fields
  sizeof(psdk_interfaces::msg::FileInfo),
  FileInfo_message_member_array,  // message members
  FileInfo_init_function,  // function to initialize message memory (memory has to be allocated)
  FileInfo_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t FileInfo_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &FileInfo_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace psdk_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<psdk_interfaces::msg::FileInfo>()
{
  return &::psdk_interfaces::msg::rosidl_typesupport_introspection_cpp::FileInfo_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, psdk_interfaces, msg, FileInfo)() {
  return &::psdk_interfaces::msg::rosidl_typesupport_introspection_cpp::FileInfo_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
