// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/FlightAnomaly.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/flight_anomaly__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FlightAnomaly & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: impact_in_air
  {
    out << "impact_in_air: ";
    rosidl_generator_traits::value_to_yaml(msg.impact_in_air, out);
    out << ", ";
  }

  // member: random_fly
  {
    out << "random_fly: ";
    rosidl_generator_traits::value_to_yaml(msg.random_fly, out);
    out << ", ";
  }

  // member: height_ctrl_fail
  {
    out << "height_ctrl_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.height_ctrl_fail, out);
    out << ", ";
  }

  // member: roll_pitch_ctrl_fail
  {
    out << "roll_pitch_ctrl_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_pitch_ctrl_fail, out);
    out << ", ";
  }

  // member: yaw_ctrl_fail
  {
    out << "yaw_ctrl_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw_ctrl_fail, out);
    out << ", ";
  }

  // member: aircraft_is_falling
  {
    out << "aircraft_is_falling: ";
    rosidl_generator_traits::value_to_yaml(msg.aircraft_is_falling, out);
    out << ", ";
  }

  // member: strong_wind_level1
  {
    out << "strong_wind_level1: ";
    rosidl_generator_traits::value_to_yaml(msg.strong_wind_level1, out);
    out << ", ";
  }

  // member: strong_wind_level2
  {
    out << "strong_wind_level2: ";
    rosidl_generator_traits::value_to_yaml(msg.strong_wind_level2, out);
    out << ", ";
  }

  // member: compass_installation_error
  {
    out << "compass_installation_error: ";
    rosidl_generator_traits::value_to_yaml(msg.compass_installation_error, out);
    out << ", ";
  }

  // member: imu_installation_error
  {
    out << "imu_installation_error: ";
    rosidl_generator_traits::value_to_yaml(msg.imu_installation_error, out);
    out << ", ";
  }

  // member: esc_temperature_high
  {
    out << "esc_temperature_high: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_temperature_high, out);
    out << ", ";
  }

  // member: at_least_one_esc_disconnected
  {
    out << "at_least_one_esc_disconnected: ";
    rosidl_generator_traits::value_to_yaml(msg.at_least_one_esc_disconnected, out);
    out << ", ";
  }

  // member: gps_yaw_error
  {
    out << "gps_yaw_error: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_yaw_error, out);
    out << ", ";
  }

  // member: reserved
  {
    out << "reserved: ";
    rosidl_generator_traits::value_to_yaml(msg.reserved, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FlightAnomaly & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: impact_in_air
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "impact_in_air: ";
    rosidl_generator_traits::value_to_yaml(msg.impact_in_air, out);
    out << "\n";
  }

  // member: random_fly
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "random_fly: ";
    rosidl_generator_traits::value_to_yaml(msg.random_fly, out);
    out << "\n";
  }

  // member: height_ctrl_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "height_ctrl_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.height_ctrl_fail, out);
    out << "\n";
  }

  // member: roll_pitch_ctrl_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_pitch_ctrl_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_pitch_ctrl_fail, out);
    out << "\n";
  }

  // member: yaw_ctrl_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw_ctrl_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw_ctrl_fail, out);
    out << "\n";
  }

  // member: aircraft_is_falling
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aircraft_is_falling: ";
    rosidl_generator_traits::value_to_yaml(msg.aircraft_is_falling, out);
    out << "\n";
  }

  // member: strong_wind_level1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "strong_wind_level1: ";
    rosidl_generator_traits::value_to_yaml(msg.strong_wind_level1, out);
    out << "\n";
  }

  // member: strong_wind_level2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "strong_wind_level2: ";
    rosidl_generator_traits::value_to_yaml(msg.strong_wind_level2, out);
    out << "\n";
  }

  // member: compass_installation_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "compass_installation_error: ";
    rosidl_generator_traits::value_to_yaml(msg.compass_installation_error, out);
    out << "\n";
  }

  // member: imu_installation_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_installation_error: ";
    rosidl_generator_traits::value_to_yaml(msg.imu_installation_error, out);
    out << "\n";
  }

  // member: esc_temperature_high
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "esc_temperature_high: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_temperature_high, out);
    out << "\n";
  }

  // member: at_least_one_esc_disconnected
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "at_least_one_esc_disconnected: ";
    rosidl_generator_traits::value_to_yaml(msg.at_least_one_esc_disconnected, out);
    out << "\n";
  }

  // member: gps_yaw_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_yaw_error: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_yaw_error, out);
    out << "\n";
  }

  // member: reserved
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reserved: ";
    rosidl_generator_traits::value_to_yaml(msg.reserved, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FlightAnomaly & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::FlightAnomaly & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::FlightAnomaly & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::FlightAnomaly>()
{
  return "psdk_interfaces::msg::FlightAnomaly";
}

template<>
inline const char * name<psdk_interfaces::msg::FlightAnomaly>()
{
  return "psdk_interfaces/msg/FlightAnomaly";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::FlightAnomaly>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::FlightAnomaly>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::FlightAnomaly>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__TRAITS_HPP_
