// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/GimbalRotation.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/gimbal_rotation__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
psdk_interfaces__msg__GimbalRotation__init(psdk_interfaces__msg__GimbalRotation * msg)
{
  if (!msg) {
    return false;
  }
  // payload_index
  msg->payload_index = 1;
  // rotation_mode
  // pitch
  // roll
  // yaw
  // time
  return true;
}

void
psdk_interfaces__msg__GimbalRotation__fini(psdk_interfaces__msg__GimbalRotation * msg)
{
  if (!msg) {
    return;
  }
  // payload_index
  // rotation_mode
  // pitch
  // roll
  // yaw
  // time
}

bool
psdk_interfaces__msg__GimbalRotation__are_equal(const psdk_interfaces__msg__GimbalRotation * lhs, const psdk_interfaces__msg__GimbalRotation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // payload_index
  if (lhs->payload_index != rhs->payload_index) {
    return false;
  }
  // rotation_mode
  if (lhs->rotation_mode != rhs->rotation_mode) {
    return false;
  }
  // pitch
  if (lhs->pitch != rhs->pitch) {
    return false;
  }
  // roll
  if (lhs->roll != rhs->roll) {
    return false;
  }
  // yaw
  if (lhs->yaw != rhs->yaw) {
    return false;
  }
  // time
  if (lhs->time != rhs->time) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__GimbalRotation__copy(
  const psdk_interfaces__msg__GimbalRotation * input,
  psdk_interfaces__msg__GimbalRotation * output)
{
  if (!input || !output) {
    return false;
  }
  // payload_index
  output->payload_index = input->payload_index;
  // rotation_mode
  output->rotation_mode = input->rotation_mode;
  // pitch
  output->pitch = input->pitch;
  // roll
  output->roll = input->roll;
  // yaw
  output->yaw = input->yaw;
  // time
  output->time = input->time;
  return true;
}

psdk_interfaces__msg__GimbalRotation *
psdk_interfaces__msg__GimbalRotation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__GimbalRotation * msg = (psdk_interfaces__msg__GimbalRotation *)allocator.allocate(sizeof(psdk_interfaces__msg__GimbalRotation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__GimbalRotation));
  bool success = psdk_interfaces__msg__GimbalRotation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__GimbalRotation__destroy(psdk_interfaces__msg__GimbalRotation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__GimbalRotation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__GimbalRotation__Sequence__init(psdk_interfaces__msg__GimbalRotation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__GimbalRotation * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__GimbalRotation *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__GimbalRotation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__GimbalRotation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__GimbalRotation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__GimbalRotation__Sequence__fini(psdk_interfaces__msg__GimbalRotation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__GimbalRotation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__GimbalRotation__Sequence *
psdk_interfaces__msg__GimbalRotation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__GimbalRotation__Sequence * array = (psdk_interfaces__msg__GimbalRotation__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__GimbalRotation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__GimbalRotation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__GimbalRotation__Sequence__destroy(psdk_interfaces__msg__GimbalRotation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__GimbalRotation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__GimbalRotation__Sequence__are_equal(const psdk_interfaces__msg__GimbalRotation__Sequence * lhs, const psdk_interfaces__msg__GimbalRotation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__GimbalRotation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__GimbalRotation__Sequence__copy(
  const psdk_interfaces__msg__GimbalRotation__Sequence * input,
  psdk_interfaces__msg__GimbalRotation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__GimbalRotation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__GimbalRotation * data =
      (psdk_interfaces__msg__GimbalRotation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__GimbalRotation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__GimbalRotation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__GimbalRotation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
