// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/GimbalStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/gimbal_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const GimbalStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: mount_status
  {
    out << "mount_status: ";
    rosidl_generator_traits::value_to_yaml(msg.mount_status, out);
    out << ", ";
  }

  // member: is_busy
  {
    out << "is_busy: ";
    rosidl_generator_traits::value_to_yaml(msg.is_busy, out);
    out << ", ";
  }

  // member: pitch_limited
  {
    out << "pitch_limited: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch_limited, out);
    out << ", ";
  }

  // member: roll_limited
  {
    out << "roll_limited: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_limited, out);
    out << ", ";
  }

  // member: yaw_limited
  {
    out << "yaw_limited: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw_limited, out);
    out << ", ";
  }

  // member: calibrating
  {
    out << "calibrating: ";
    rosidl_generator_traits::value_to_yaml(msg.calibrating, out);
    out << ", ";
  }

  // member: prev_calibration_result
  {
    out << "prev_calibration_result: ";
    rosidl_generator_traits::value_to_yaml(msg.prev_calibration_result, out);
    out << ", ";
  }

  // member: installed_direction
  {
    out << "installed_direction: ";
    rosidl_generator_traits::value_to_yaml(msg.installed_direction, out);
    out << ", ";
  }

  // member: disabled_mvo
  {
    out << "disabled_mvo: ";
    rosidl_generator_traits::value_to_yaml(msg.disabled_mvo, out);
    out << ", ";
  }

  // member: gear_show_unable
  {
    out << "gear_show_unable: ";
    rosidl_generator_traits::value_to_yaml(msg.gear_show_unable, out);
    out << ", ";
  }

  // member: gyro_falut
  {
    out << "gyro_falut: ";
    rosidl_generator_traits::value_to_yaml(msg.gyro_falut, out);
    out << ", ";
  }

  // member: esc_pitch_status
  {
    out << "esc_pitch_status: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_pitch_status, out);
    out << ", ";
  }

  // member: esc_roll_status
  {
    out << "esc_roll_status: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_roll_status, out);
    out << ", ";
  }

  // member: esc_yaw_status
  {
    out << "esc_yaw_status: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_yaw_status, out);
    out << ", ";
  }

  // member: drone_data_recv
  {
    out << "drone_data_recv: ";
    rosidl_generator_traits::value_to_yaml(msg.drone_data_recv, out);
    out << ", ";
  }

  // member: init_unfinished
  {
    out << "init_unfinished: ";
    rosidl_generator_traits::value_to_yaml(msg.init_unfinished, out);
    out << ", ";
  }

  // member: fw_updating
  {
    out << "fw_updating: ";
    rosidl_generator_traits::value_to_yaml(msg.fw_updating, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GimbalStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: mount_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mount_status: ";
    rosidl_generator_traits::value_to_yaml(msg.mount_status, out);
    out << "\n";
  }

  // member: is_busy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_busy: ";
    rosidl_generator_traits::value_to_yaml(msg.is_busy, out);
    out << "\n";
  }

  // member: pitch_limited
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch_limited: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch_limited, out);
    out << "\n";
  }

  // member: roll_limited
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_limited: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_limited, out);
    out << "\n";
  }

  // member: yaw_limited
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw_limited: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw_limited, out);
    out << "\n";
  }

  // member: calibrating
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "calibrating: ";
    rosidl_generator_traits::value_to_yaml(msg.calibrating, out);
    out << "\n";
  }

  // member: prev_calibration_result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prev_calibration_result: ";
    rosidl_generator_traits::value_to_yaml(msg.prev_calibration_result, out);
    out << "\n";
  }

  // member: installed_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "installed_direction: ";
    rosidl_generator_traits::value_to_yaml(msg.installed_direction, out);
    out << "\n";
  }

  // member: disabled_mvo
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "disabled_mvo: ";
    rosidl_generator_traits::value_to_yaml(msg.disabled_mvo, out);
    out << "\n";
  }

  // member: gear_show_unable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gear_show_unable: ";
    rosidl_generator_traits::value_to_yaml(msg.gear_show_unable, out);
    out << "\n";
  }

  // member: gyro_falut
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gyro_falut: ";
    rosidl_generator_traits::value_to_yaml(msg.gyro_falut, out);
    out << "\n";
  }

  // member: esc_pitch_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "esc_pitch_status: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_pitch_status, out);
    out << "\n";
  }

  // member: esc_roll_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "esc_roll_status: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_roll_status, out);
    out << "\n";
  }

  // member: esc_yaw_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "esc_yaw_status: ";
    rosidl_generator_traits::value_to_yaml(msg.esc_yaw_status, out);
    out << "\n";
  }

  // member: drone_data_recv
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "drone_data_recv: ";
    rosidl_generator_traits::value_to_yaml(msg.drone_data_recv, out);
    out << "\n";
  }

  // member: init_unfinished
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "init_unfinished: ";
    rosidl_generator_traits::value_to_yaml(msg.init_unfinished, out);
    out << "\n";
  }

  // member: fw_updating
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fw_updating: ";
    rosidl_generator_traits::value_to_yaml(msg.fw_updating, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GimbalStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::GimbalStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::GimbalStatus & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::GimbalStatus>()
{
  return "psdk_interfaces::msg::GimbalStatus";
}

template<>
inline const char * name<psdk_interfaces::msg::GimbalStatus>()
{
  return "psdk_interfaces/msg/GimbalStatus";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::GimbalStatus>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::GimbalStatus>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::GimbalStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__TRAITS_HPP_
