// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from psdk_interfaces:msg/GPSDetails.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__BUILDER_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "psdk_interfaces/msg/detail/gps_details__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace psdk_interfaces
{

namespace msg
{

namespace builder
{

class Init_GPSDetails_gps_counter
{
public:
  explicit Init_GPSDetails_gps_counter(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  ::psdk_interfaces::msg::GPSDetails gps_counter(::psdk_interfaces::msg::GPSDetails::_gps_counter_type arg)
  {
    msg_.gps_counter = std::move(arg);
    return std::move(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_num_total_satellites_used
{
public:
  explicit Init_GPSDetails_num_total_satellites_used(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_gps_counter num_total_satellites_used(::psdk_interfaces::msg::GPSDetails::_num_total_satellites_used_type arg)
  {
    msg_.num_total_satellites_used = std::move(arg);
    return Init_GPSDetails_gps_counter(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_num_glonass_satellites_used
{
public:
  explicit Init_GPSDetails_num_glonass_satellites_used(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_num_total_satellites_used num_glonass_satellites_used(::psdk_interfaces::msg::GPSDetails::_num_glonass_satellites_used_type arg)
  {
    msg_.num_glonass_satellites_used = std::move(arg);
    return Init_GPSDetails_num_total_satellites_used(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_num_gps_satellites_used
{
public:
  explicit Init_GPSDetails_num_gps_satellites_used(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_num_glonass_satellites_used num_gps_satellites_used(::psdk_interfaces::msg::GPSDetails::_num_gps_satellites_used_type arg)
  {
    msg_.num_gps_satellites_used = std::move(arg);
    return Init_GPSDetails_num_glonass_satellites_used(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_speed_accuracy
{
public:
  explicit Init_GPSDetails_speed_accuracy(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_num_gps_satellites_used speed_accuracy(::psdk_interfaces::msg::GPSDetails::_speed_accuracy_type arg)
  {
    msg_.speed_accuracy = std::move(arg);
    return Init_GPSDetails_num_gps_satellites_used(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_horizontal_accuracy
{
public:
  explicit Init_GPSDetails_horizontal_accuracy(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_speed_accuracy horizontal_accuracy(::psdk_interfaces::msg::GPSDetails::_horizontal_accuracy_type arg)
  {
    msg_.horizontal_accuracy = std::move(arg);
    return Init_GPSDetails_speed_accuracy(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_vertical_accuracy
{
public:
  explicit Init_GPSDetails_vertical_accuracy(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_horizontal_accuracy vertical_accuracy(::psdk_interfaces::msg::GPSDetails::_vertical_accuracy_type arg)
  {
    msg_.vertical_accuracy = std::move(arg);
    return Init_GPSDetails_horizontal_accuracy(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_fix_state
{
public:
  explicit Init_GPSDetails_fix_state(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_vertical_accuracy fix_state(::psdk_interfaces::msg::GPSDetails::_fix_state_type arg)
  {
    msg_.fix_state = std::move(arg);
    return Init_GPSDetails_vertical_accuracy(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_position_dop
{
public:
  explicit Init_GPSDetails_position_dop(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_fix_state position_dop(::psdk_interfaces::msg::GPSDetails::_position_dop_type arg)
  {
    msg_.position_dop = std::move(arg);
    return Init_GPSDetails_fix_state(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_horizontal_dop
{
public:
  explicit Init_GPSDetails_horizontal_dop(::psdk_interfaces::msg::GPSDetails & msg)
  : msg_(msg)
  {}
  Init_GPSDetails_position_dop horizontal_dop(::psdk_interfaces::msg::GPSDetails::_horizontal_dop_type arg)
  {
    msg_.horizontal_dop = std::move(arg);
    return Init_GPSDetails_position_dop(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

class Init_GPSDetails_header
{
public:
  Init_GPSDetails_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_GPSDetails_horizontal_dop header(::psdk_interfaces::msg::GPSDetails::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_GPSDetails_horizontal_dop(msg_);
  }

private:
  ::psdk_interfaces::msg::GPSDetails msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::psdk_interfaces::msg::GPSDetails>()
{
  return psdk_interfaces::msg::builder::Init_GPSDetails_header();
}

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__BUILDER_HPP_
