// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/GPSDetails.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/gps_details__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const GPSDetails & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: horizontal_dop
  {
    out << "horizontal_dop: ";
    rosidl_generator_traits::value_to_yaml(msg.horizontal_dop, out);
    out << ", ";
  }

  // member: position_dop
  {
    out << "position_dop: ";
    rosidl_generator_traits::value_to_yaml(msg.position_dop, out);
    out << ", ";
  }

  // member: fix_state
  {
    out << "fix_state: ";
    rosidl_generator_traits::value_to_yaml(msg.fix_state, out);
    out << ", ";
  }

  // member: vertical_accuracy
  {
    out << "vertical_accuracy: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_accuracy, out);
    out << ", ";
  }

  // member: horizontal_accuracy
  {
    out << "horizontal_accuracy: ";
    rosidl_generator_traits::value_to_yaml(msg.horizontal_accuracy, out);
    out << ", ";
  }

  // member: speed_accuracy
  {
    out << "speed_accuracy: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_accuracy, out);
    out << ", ";
  }

  // member: num_gps_satellites_used
  {
    out << "num_gps_satellites_used: ";
    rosidl_generator_traits::value_to_yaml(msg.num_gps_satellites_used, out);
    out << ", ";
  }

  // member: num_glonass_satellites_used
  {
    out << "num_glonass_satellites_used: ";
    rosidl_generator_traits::value_to_yaml(msg.num_glonass_satellites_used, out);
    out << ", ";
  }

  // member: num_total_satellites_used
  {
    out << "num_total_satellites_used: ";
    rosidl_generator_traits::value_to_yaml(msg.num_total_satellites_used, out);
    out << ", ";
  }

  // member: gps_counter
  {
    out << "gps_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_counter, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GPSDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: horizontal_dop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "horizontal_dop: ";
    rosidl_generator_traits::value_to_yaml(msg.horizontal_dop, out);
    out << "\n";
  }

  // member: position_dop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_dop: ";
    rosidl_generator_traits::value_to_yaml(msg.position_dop, out);
    out << "\n";
  }

  // member: fix_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fix_state: ";
    rosidl_generator_traits::value_to_yaml(msg.fix_state, out);
    out << "\n";
  }

  // member: vertical_accuracy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_accuracy: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_accuracy, out);
    out << "\n";
  }

  // member: horizontal_accuracy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "horizontal_accuracy: ";
    rosidl_generator_traits::value_to_yaml(msg.horizontal_accuracy, out);
    out << "\n";
  }

  // member: speed_accuracy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_accuracy: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_accuracy, out);
    out << "\n";
  }

  // member: num_gps_satellites_used
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_gps_satellites_used: ";
    rosidl_generator_traits::value_to_yaml(msg.num_gps_satellites_used, out);
    out << "\n";
  }

  // member: num_glonass_satellites_used
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_glonass_satellites_used: ";
    rosidl_generator_traits::value_to_yaml(msg.num_glonass_satellites_used, out);
    out << "\n";
  }

  // member: num_total_satellites_used
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_total_satellites_used: ";
    rosidl_generator_traits::value_to_yaml(msg.num_total_satellites_used, out);
    out << "\n";
  }

  // member: gps_counter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_counter, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GPSDetails & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::GPSDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::GPSDetails & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::GPSDetails>()
{
  return "psdk_interfaces::msg::GPSDetails";
}

template<>
inline const char * name<psdk_interfaces::msg::GPSDetails>()
{
  return "psdk_interfaces/msg/GPSDetails";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::GPSDetails>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::GPSDetails>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::GPSDetails>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__TRAITS_HPP_
