// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/HmsInfoMsg.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__HmsInfoMsg __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__HmsInfoMsg __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HmsInfoMsg_
{
  using Type = HmsInfoMsg_<ContainerAllocator>;

  explicit HmsInfoMsg_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->error_code = 0ul;
      this->component_index = 0;
      this->error_level = 0;
      this->ground_info = "";
      this->fly_info = "";
    }
  }

  explicit HmsInfoMsg_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : ground_info(_alloc),
    fly_info(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->error_code = 0ul;
      this->component_index = 0;
      this->error_level = 0;
      this->ground_info = "";
      this->fly_info = "";
    }
  }

  // field types and members
  using _error_code_type =
    uint32_t;
  _error_code_type error_code;
  using _component_index_type =
    uint8_t;
  _component_index_type component_index;
  using _error_level_type =
    uint8_t;
  _error_level_type error_level;
  using _ground_info_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ground_info_type ground_info;
  using _fly_info_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _fly_info_type fly_info;

  // setters for named parameter idiom
  Type & set__error_code(
    const uint32_t & _arg)
  {
    this->error_code = _arg;
    return *this;
  }
  Type & set__component_index(
    const uint8_t & _arg)
  {
    this->component_index = _arg;
    return *this;
  }
  Type & set__error_level(
    const uint8_t & _arg)
  {
    this->error_level = _arg;
    return *this;
  }
  Type & set__ground_info(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ground_info = _arg;
    return *this;
  }
  Type & set__fly_info(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->fly_info = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN_HMS_ERROR_LEVEL =
    0u;
  static constexpr uint8_t MID_HMS_ERROR_LEVEL =
    3u;
  static constexpr uint8_t MAX_HMS_ERROR_LEVEL =
    6u;

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__HmsInfoMsg
    std::shared_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__HmsInfoMsg
    std::shared_ptr<psdk_interfaces::msg::HmsInfoMsg_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HmsInfoMsg_ & other) const
  {
    if (this->error_code != other.error_code) {
      return false;
    }
    if (this->component_index != other.component_index) {
      return false;
    }
    if (this->error_level != other.error_level) {
      return false;
    }
    if (this->ground_info != other.ground_info) {
      return false;
    }
    if (this->fly_info != other.fly_info) {
      return false;
    }
    return true;
  }
  bool operator!=(const HmsInfoMsg_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HmsInfoMsg_

// alias to use template instance with default allocator
using HmsInfoMsg =
  psdk_interfaces::msg::HmsInfoMsg_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HmsInfoMsg_<ContainerAllocator>::MIN_HMS_ERROR_LEVEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HmsInfoMsg_<ContainerAllocator>::MID_HMS_ERROR_LEVEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HmsInfoMsg_<ContainerAllocator>::MAX_HMS_ERROR_LEVEL;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__STRUCT_HPP_
