// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/HmsInfoMsg.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/hms_info_msg__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const HmsInfoMsg & msg,
  std::ostream & out)
{
  out << "{";
  // member: error_code
  {
    out << "error_code: ";
    rosidl_generator_traits::value_to_yaml(msg.error_code, out);
    out << ", ";
  }

  // member: component_index
  {
    out << "component_index: ";
    rosidl_generator_traits::value_to_yaml(msg.component_index, out);
    out << ", ";
  }

  // member: error_level
  {
    out << "error_level: ";
    rosidl_generator_traits::value_to_yaml(msg.error_level, out);
    out << ", ";
  }

  // member: ground_info
  {
    out << "ground_info: ";
    rosidl_generator_traits::value_to_yaml(msg.ground_info, out);
    out << ", ";
  }

  // member: fly_info
  {
    out << "fly_info: ";
    rosidl_generator_traits::value_to_yaml(msg.fly_info, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HmsInfoMsg & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: error_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error_code: ";
    rosidl_generator_traits::value_to_yaml(msg.error_code, out);
    out << "\n";
  }

  // member: component_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "component_index: ";
    rosidl_generator_traits::value_to_yaml(msg.component_index, out);
    out << "\n";
  }

  // member: error_level
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error_level: ";
    rosidl_generator_traits::value_to_yaml(msg.error_level, out);
    out << "\n";
  }

  // member: ground_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ground_info: ";
    rosidl_generator_traits::value_to_yaml(msg.ground_info, out);
    out << "\n";
  }

  // member: fly_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fly_info: ";
    rosidl_generator_traits::value_to_yaml(msg.fly_info, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HmsInfoMsg & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::HmsInfoMsg & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::HmsInfoMsg & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::HmsInfoMsg>()
{
  return "psdk_interfaces::msg::HmsInfoMsg";
}

template<>
inline const char * name<psdk_interfaces::msg::HmsInfoMsg>()
{
  return "psdk_interfaces/msg/HmsInfoMsg";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::HmsInfoMsg>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::HmsInfoMsg>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<psdk_interfaces::msg::HmsInfoMsg>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__TRAITS_HPP_
