// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/HmsInfoTable.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_TABLE__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_TABLE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/hms_info_table__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'table'
#include "psdk_interfaces/msg/detail/hms_info_msg__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const HmsInfoTable & msg,
  std::ostream & out)
{
  out << "{";
  // member: num_msg
  {
    out << "num_msg: ";
    rosidl_generator_traits::value_to_yaml(msg.num_msg, out);
    out << ", ";
  }

  // member: table
  {
    if (msg.table.size() == 0) {
      out << "table: []";
    } else {
      out << "table: [";
      size_t pending_items = msg.table.size();
      for (auto item : msg.table) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HmsInfoTable & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: num_msg
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_msg: ";
    rosidl_generator_traits::value_to_yaml(msg.num_msg, out);
    out << "\n";
  }

  // member: table
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.table.size() == 0) {
      out << "table: []\n";
    } else {
      out << "table:\n";
      for (auto item : msg.table) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HmsInfoTable & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::HmsInfoTable & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::HmsInfoTable & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::HmsInfoTable>()
{
  return "psdk_interfaces::msg::HmsInfoTable";
}

template<>
inline const char * name<psdk_interfaces::msg::HmsInfoTable>()
{
  return "psdk_interfaces/msg/HmsInfoTable";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::HmsInfoTable>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::HmsInfoTable>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<psdk_interfaces::msg::HmsInfoTable>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_TABLE__TRAITS_HPP_
