// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/PositionFused.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__POSITION_FUSED__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__POSITION_FUSED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__PositionFused __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__PositionFused __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PositionFused_
{
  using Type = PositionFused_<ContainerAllocator>;

  explicit PositionFused_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x_health = 0;
      this->y_health = 0;
      this->z_health = 0;
    }
  }

  explicit PositionFused_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x_health = 0;
      this->y_health = 0;
      this->z_health = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _x_health_type =
    uint8_t;
  _x_health_type x_health;
  using _y_health_type =
    uint8_t;
  _y_health_type y_health;
  using _z_health_type =
    uint8_t;
  _z_health_type z_health;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__x_health(
    const uint8_t & _arg)
  {
    this->x_health = _arg;
    return *this;
  }
  Type & set__y_health(
    const uint8_t & _arg)
  {
    this->y_health = _arg;
    return *this;
  }
  Type & set__z_health(
    const uint8_t & _arg)
  {
    this->z_health = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::PositionFused_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::PositionFused_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::PositionFused_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::PositionFused_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__PositionFused
    std::shared_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__PositionFused
    std::shared_ptr<psdk_interfaces::msg::PositionFused_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PositionFused_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->x_health != other.x_health) {
      return false;
    }
    if (this->y_health != other.y_health) {
      return false;
    }
    if (this->z_health != other.z_health) {
      return false;
    }
    return true;
  }
  bool operator!=(const PositionFused_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PositionFused_

// alias to use template instance with default allocator
using PositionFused =
  psdk_interfaces::msg::PositionFused_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__POSITION_FUSED__STRUCT_HPP_
