// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/RCConnectionStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/RCConnectionStatus in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__RCConnectionStatus
{
  std_msgs__msg__Header header;
  /// Sky side is connected, i.e., receiver is connected to FC
  uint8_t air_connection;
  /// Ground side is connected, i.e., RC is on and connected to FC
  uint8_t ground_connection;
  /// Mobile App is connected to RC
  uint8_t app_connection;
  /// 0 if sky or ground side is disconnected for 3 seconds
  uint8_t air_or_ground_disconnected;
} psdk_interfaces__msg__RCConnectionStatus;

// Struct for a sequence of psdk_interfaces__msg__RCConnectionStatus.
typedef struct psdk_interfaces__msg__RCConnectionStatus__Sequence
{
  psdk_interfaces__msg__RCConnectionStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__RCConnectionStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__STRUCT_H_
