// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/CameraGetFileListInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FILE_LIST_INFO__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FILE_LIST_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraGetFileListInfo_Request_
{
  using Type = CameraGetFileListInfo_Request_<ContainerAllocator>;

  explicit CameraGetFileListInfo_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
    }
  }

  explicit CameraGetFileListInfo_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Request
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Request
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraGetFileListInfo_Request_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraGetFileListInfo_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraGetFileListInfo_Request_

// alias to use template instance with default allocator
using CameraGetFileListInfo_Request =
  psdk_interfaces::srv::CameraGetFileListInfo_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


// Include directives for member types
// Member 'file_list'
#include "psdk_interfaces/msg/detail/file_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraGetFileListInfo_Response_
{
  using Type = CameraGetFileListInfo_Response_<ContainerAllocator>;

  explicit CameraGetFileListInfo_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->count = 0;
    }
  }

  explicit CameraGetFileListInfo_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->count = 0;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _file_list_type =
    std::vector<psdk_interfaces::msg::FileInfo_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<psdk_interfaces::msg::FileInfo_<ContainerAllocator>>>;
  _file_list_type file_list;
  using _count_type =
    int16_t;
  _count_type count;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__file_list(
    const std::vector<psdk_interfaces::msg::FileInfo_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<psdk_interfaces::msg::FileInfo_<ContainerAllocator>>> & _arg)
  {
    this->file_list = _arg;
    return *this;
  }
  Type & set__count(
    const int16_t & _arg)
  {
    this->count = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Response
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetFileListInfo_Response
    std::shared_ptr<psdk_interfaces::srv::CameraGetFileListInfo_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraGetFileListInfo_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->file_list != other.file_list) {
      return false;
    }
    if (this->count != other.count) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraGetFileListInfo_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraGetFileListInfo_Response_

// alias to use template instance with default allocator
using CameraGetFileListInfo_Response =
  psdk_interfaces::srv::CameraGetFileListInfo_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct CameraGetFileListInfo
{
  using Request = psdk_interfaces::srv::CameraGetFileListInfo_Request;
  using Response = psdk_interfaces::srv::CameraGetFileListInfo_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FILE_LIST_INFO__STRUCT_HPP_
