// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:srv/CameraGetFileListInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FILE_LIST_INFO__TRAITS_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FILE_LIST_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/srv/detail/camera_get_file_list_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraGetFileListInfo_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: payload_index
  {
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraGetFileListInfo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: payload_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraGetFileListInfo_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::CameraGetFileListInfo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::CameraGetFileListInfo_Request & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetFileListInfo_Request>()
{
  return "psdk_interfaces::srv::CameraGetFileListInfo_Request";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetFileListInfo_Request>()
{
  return "psdk_interfaces/srv/CameraGetFileListInfo_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetFileListInfo_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetFileListInfo_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::CameraGetFileListInfo_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'file_list'
#include "psdk_interfaces/msg/detail/file_info__traits.hpp"

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraGetFileListInfo_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: file_list
  {
    if (msg.file_list.size() == 0) {
      out << "file_list: []";
    } else {
      out << "file_list: [";
      size_t pending_items = msg.file_list.size();
      for (auto item : msg.file_list) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: count
  {
    out << "count: ";
    rosidl_generator_traits::value_to_yaml(msg.count, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraGetFileListInfo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: file_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.file_list.size() == 0) {
      out << "file_list: []\n";
    } else {
      out << "file_list:\n";
      for (auto item : msg.file_list) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "count: ";
    rosidl_generator_traits::value_to_yaml(msg.count, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraGetFileListInfo_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::CameraGetFileListInfo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::CameraGetFileListInfo_Response & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetFileListInfo_Response>()
{
  return "psdk_interfaces::srv::CameraGetFileListInfo_Response";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetFileListInfo_Response>()
{
  return "psdk_interfaces/srv/CameraGetFileListInfo_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetFileListInfo_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetFileListInfo_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<psdk_interfaces::srv::CameraGetFileListInfo_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetFileListInfo>()
{
  return "psdk_interfaces::srv::CameraGetFileListInfo";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetFileListInfo>()
{
  return "psdk_interfaces/srv/CameraGetFileListInfo";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetFileListInfo>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::srv::CameraGetFileListInfo_Request>::value &&
    has_fixed_size<psdk_interfaces::srv::CameraGetFileListInfo_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetFileListInfo>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::srv::CameraGetFileListInfo_Request>::value &&
    has_bounded_size<psdk_interfaces::srv::CameraGetFileListInfo_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::srv::CameraGetFileListInfo>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::srv::CameraGetFileListInfo_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::srv::CameraGetFileListInfo_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FILE_LIST_INFO__TRAITS_HPP_
