// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/CameraGetLaserRangingInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraGetLaserRangingInfo_Request_
{
  using Type = CameraGetLaserRangingInfo_Request_<ContainerAllocator>;

  explicit CameraGetLaserRangingInfo_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
    }
  }

  explicit CameraGetLaserRangingInfo_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Request
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Request
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraGetLaserRangingInfo_Request_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraGetLaserRangingInfo_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraGetLaserRangingInfo_Request_

// alias to use template instance with default allocator
using CameraGetLaserRangingInfo_Request =
  psdk_interfaces::srv::CameraGetLaserRangingInfo_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraGetLaserRangingInfo_Response_
{
  using Type = CameraGetLaserRangingInfo_Response_<ContainerAllocator>;

  explicit CameraGetLaserRangingInfo_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->longitude = 0.0;
      this->latitude = 0.0;
      this->altitude = 0l;
      this->distance = 0l;
      this->screen_x = 0;
      this->screen_y = 0;
      this->enable_lidar = false;
      this->exception = 0;
    }
  }

  explicit CameraGetLaserRangingInfo_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->longitude = 0.0;
      this->latitude = 0.0;
      this->altitude = 0l;
      this->distance = 0l;
      this->screen_x = 0;
      this->screen_y = 0;
      this->enable_lidar = false;
      this->exception = 0;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _longitude_type =
    double;
  _longitude_type longitude;
  using _latitude_type =
    double;
  _latitude_type latitude;
  using _altitude_type =
    int32_t;
  _altitude_type altitude;
  using _distance_type =
    int32_t;
  _distance_type distance;
  using _screen_x_type =
    int16_t;
  _screen_x_type screen_x;
  using _screen_y_type =
    int16_t;
  _screen_y_type screen_y;
  using _enable_lidar_type =
    bool;
  _enable_lidar_type enable_lidar;
  using _exception_type =
    uint8_t;
  _exception_type exception;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__longitude(
    const double & _arg)
  {
    this->longitude = _arg;
    return *this;
  }
  Type & set__latitude(
    const double & _arg)
  {
    this->latitude = _arg;
    return *this;
  }
  Type & set__altitude(
    const int32_t & _arg)
  {
    this->altitude = _arg;
    return *this;
  }
  Type & set__distance(
    const int32_t & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__screen_x(
    const int16_t & _arg)
  {
    this->screen_x = _arg;
    return *this;
  }
  Type & set__screen_y(
    const int16_t & _arg)
  {
    this->screen_y = _arg;
    return *this;
  }
  Type & set__enable_lidar(
    const bool & _arg)
  {
    this->enable_lidar = _arg;
    return *this;
  }
  Type & set__exception(
    const uint8_t & _arg)
  {
    this->exception = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Response
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetLaserRangingInfo_Response
    std::shared_ptr<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraGetLaserRangingInfo_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->longitude != other.longitude) {
      return false;
    }
    if (this->latitude != other.latitude) {
      return false;
    }
    if (this->altitude != other.altitude) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->screen_x != other.screen_x) {
      return false;
    }
    if (this->screen_y != other.screen_y) {
      return false;
    }
    if (this->enable_lidar != other.enable_lidar) {
      return false;
    }
    if (this->exception != other.exception) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraGetLaserRangingInfo_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraGetLaserRangingInfo_Response_

// alias to use template instance with default allocator
using CameraGetLaserRangingInfo_Response =
  psdk_interfaces::srv::CameraGetLaserRangingInfo_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct CameraGetLaserRangingInfo
{
  using Request = psdk_interfaces::srv::CameraGetLaserRangingInfo_Request;
  using Response = psdk_interfaces::srv::CameraGetLaserRangingInfo_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__STRUCT_HPP_
