// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/CameraGetType.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_TYPE__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_TYPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraGetType_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraGetType_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraGetType_Request_
{
  using Type = CameraGetType_Request_<ContainerAllocator>;

  explicit CameraGetType_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
    }
  }

  explicit CameraGetType_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetType_Request
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetType_Request
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraGetType_Request_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraGetType_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraGetType_Request_

// alias to use template instance with default allocator
using CameraGetType_Request =
  psdk_interfaces::srv::CameraGetType_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraGetType_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraGetType_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraGetType_Response_
{
  using Type = CameraGetType_Response_<ContainerAllocator>;

  explicit CameraGetType_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->camera_type = "";
    }
  }

  explicit CameraGetType_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : camera_type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->camera_type = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _camera_type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _camera_type_type camera_type;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__camera_type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->camera_type = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetType_Response
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraGetType_Response
    std::shared_ptr<psdk_interfaces::srv::CameraGetType_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraGetType_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->camera_type != other.camera_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraGetType_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraGetType_Response_

// alias to use template instance with default allocator
using CameraGetType_Response =
  psdk_interfaces::srv::CameraGetType_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct CameraGetType
{
  using Request = psdk_interfaces::srv::CameraGetType_Request;
  using Response = psdk_interfaces::srv::CameraGetType_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_TYPE__STRUCT_HPP_
