// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:srv/CameraSetFocusTarget.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_SET_FOCUS_TARGET__STRUCT_H_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_SET_FOCUS_TARGET__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/CameraSetFocusTarget in the package psdk_interfaces.
typedef struct psdk_interfaces__srv__CameraSetFocusTarget_Request
{
  /// see enum E_DjiMountPosition in dji_typedef.h
  uint8_t payload_index;
  /// see enum T_DjiCameraPointInScreen in dji_typedef.h # *!< Specifies horizontal zone coordinate. This parameter is between 0 and 1.
  /// The point [0.0, 0.0] represents the top-left angle of the screen.*/
  float x_target;
  /// see enum T_DjiCameraPointInScreen in dji_typedef.h /*!< Specifies vertical zone coordinate. This parameter is between 0 and 1. */
  float y_target;
} psdk_interfaces__srv__CameraSetFocusTarget_Request;

// Struct for a sequence of psdk_interfaces__srv__CameraSetFocusTarget_Request.
typedef struct psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence
{
  psdk_interfaces__srv__CameraSetFocusTarget_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/CameraSetFocusTarget in the package psdk_interfaces.
typedef struct psdk_interfaces__srv__CameraSetFocusTarget_Response
{
  bool success;
} psdk_interfaces__srv__CameraSetFocusTarget_Response;

// Struct for a sequence of psdk_interfaces__srv__CameraSetFocusTarget_Response.
typedef struct psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence
{
  psdk_interfaces__srv__CameraSetFocusTarget_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_SET_FOCUS_TARGET__STRUCT_H_
