// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/GimbalSetMode.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__GIMBAL_SET_MODE__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__GIMBAL_SET_MODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GimbalSetMode_Request_
{
  using Type = GimbalSetMode_Request_<ContainerAllocator>;

  explicit GimbalSetMode_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->gimbal_mode = 0;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gimbal_mode = 0;
    }
  }

  explicit GimbalSetMode_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->gimbal_mode = 0;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gimbal_mode = 0;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;
  using _gimbal_mode_type =
    uint8_t;
  _gimbal_mode_type gimbal_mode;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }
  Type & set__gimbal_mode(
    const uint8_t & _arg)
  {
    this->gimbal_mode = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Request
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Request
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GimbalSetMode_Request_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    if (this->gimbal_mode != other.gimbal_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const GimbalSetMode_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GimbalSetMode_Request_

// alias to use template instance with default allocator
using GimbalSetMode_Request =
  psdk_interfaces::srv::GimbalSetMode_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GimbalSetMode_Response_
{
  using Type = GimbalSetMode_Response_<ContainerAllocator>;

  explicit GimbalSetMode_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit GimbalSetMode_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Response
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__GimbalSetMode_Response
    std::shared_ptr<psdk_interfaces::srv::GimbalSetMode_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GimbalSetMode_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const GimbalSetMode_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GimbalSetMode_Response_

// alias to use template instance with default allocator
using GimbalSetMode_Response =
  psdk_interfaces::srv::GimbalSetMode_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct GimbalSetMode
{
  using Request = psdk_interfaces::srv::GimbalSetMode_Request;
  using Response = psdk_interfaces::srv::GimbalSetMode_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__GIMBAL_SET_MODE__STRUCT_HPP_
