// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:action/CameraDeleteFileByIndex.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/action/detail/camera_delete_file_by_index__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__init(psdk_interfaces__action__CameraDeleteFileByIndex_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // payload_index
  msg->payload_index = 1;
  // file_index
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__fini(psdk_interfaces__action__CameraDeleteFileByIndex_Goal * msg)
{
  if (!msg) {
    return;
  }
  // payload_index
  // file_index
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_Goal * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // payload_index
  if (lhs->payload_index != rhs->payload_index) {
    return false;
  }
  // file_index
  if (lhs->file_index != rhs->file_index) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_Goal * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // payload_index
  output->payload_index = input->payload_index;
  // file_index
  output->file_index = input->file_index;
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_Goal *
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_Goal *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Goal));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_Goal *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Goal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_Goal * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_Goal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_Goal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_Goal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_Result__init(psdk_interfaces__action__CameraDeleteFileByIndex_Result * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Result__fini(psdk_interfaces__action__CameraDeleteFileByIndex_Result * msg)
{
  if (!msg) {
    return;
  }
  // success
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Result__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_Result * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Result__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_Result * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_Result *
psdk_interfaces__action__CameraDeleteFileByIndex_Result__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Result * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_Result *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Result));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Result__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Result * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_Result *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Result);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_Result * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_Result *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_Result__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_Result__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__init(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__fini(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_Feedback *
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_Feedback *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_Feedback *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_Feedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_Feedback * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_Feedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__functions.h"

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__init(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Goal__init(&msg->goal)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  psdk_interfaces__action__CameraDeleteFileByIndex_Goal__fini(&msg->goal);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request *
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__init(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__fini(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response *
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__init(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__fini(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request *
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__functions.h"

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__init(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Result__init(&msg->result)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__fini(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  psdk_interfaces__action__CameraDeleteFileByIndex_Result__fini(&msg->result);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response *
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__functions.h"

bool
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__init(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__init(&msg->feedback)) {
    psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__fini(&msg->feedback);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!psdk_interfaces__action__CameraDeleteFileByIndex_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage *
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * msg = (psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage));
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__init(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * data = NULL;

  if (size) {
    data = (psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage *)allocator.zero_allocate(size, sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__fini(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence *
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * array = (psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence *)allocator.allocate(sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__destroy(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__are_equal(const psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * lhs, const psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence__copy(
  const psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * input,
  psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage * data =
      (psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
