// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:action/CameraDeleteFileByIndex.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__STRUCT_HPP_
#define PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Goal __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Goal __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_Goal_
{
  using Type = CameraDeleteFileByIndex_Goal_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->file_index = 0ul;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->file_index = 0ul;
    }
  }

  explicit CameraDeleteFileByIndex_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->file_index = 0ul;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->file_index = 0ul;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;
  using _file_index_type =
    uint32_t;
  _file_index_type file_index;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }
  Type & set__file_index(
    const uint32_t & _arg)
  {
    this->file_index = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Goal
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Goal
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_Goal_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    if (this->file_index != other.file_index) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_Goal_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_Goal =
  psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Result __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Result __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_Result_
{
  using Type = CameraDeleteFileByIndex_Result_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit CameraDeleteFileByIndex_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Result
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Result
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_Result_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_Result_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_Result =
  psdk_interfaces::action::CameraDeleteFileByIndex_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Feedback __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_Feedback_
{
  using Type = CameraDeleteFileByIndex_Feedback_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit CameraDeleteFileByIndex_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Feedback
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_Feedback
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_Feedback_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_Feedback_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_Feedback =
  psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_SendGoal_Request_
{
  using Type = CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit CameraDeleteFileByIndex_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const psdk_interfaces::action::CameraDeleteFileByIndex_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Request
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_SendGoal_Request_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_SendGoal_Request =
  psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_SendGoal_Response_
{
  using Type = CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit CameraDeleteFileByIndex_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_SendGoal_Response
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_SendGoal_Response_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_SendGoal_Response =
  psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace action
{

struct CameraDeleteFileByIndex_SendGoal
{
  using Request = psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request;
  using Response = psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response;
};

}  // namespace action

}  // namespace psdk_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_GetResult_Request_
{
  using Type = CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit CameraDeleteFileByIndex_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Request
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_GetResult_Request_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_GetResult_Request =
  psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces


// Include directives for member types
// Member 'result'
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_GetResult_Response_
{
  using Type = CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit CameraDeleteFileByIndex_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const psdk_interfaces::action::CameraDeleteFileByIndex_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_GetResult_Response
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_GetResult_Response_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_GetResult_Response =
  psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace action
{

struct CameraDeleteFileByIndex_GetResult
{
  using Request = psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request;
  using Response = psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response;
};

}  // namespace action

}  // namespace psdk_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct CameraDeleteFileByIndex_FeedbackMessage_
{
  using Type = CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>;

  explicit CameraDeleteFileByIndex_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit CameraDeleteFileByIndex_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const psdk_interfaces::action::CameraDeleteFileByIndex_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__action__CameraDeleteFileByIndex_FeedbackMessage
    std::shared_ptr<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraDeleteFileByIndex_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraDeleteFileByIndex_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraDeleteFileByIndex_FeedbackMessage_

// alias to use template instance with default allocator
using CameraDeleteFileByIndex_FeedbackMessage =
  psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace psdk_interfaces

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace psdk_interfaces
{

namespace action
{

struct CameraDeleteFileByIndex
{
  /// The goal message defined in the action definition.
  using Goal = psdk_interfaces::action::CameraDeleteFileByIndex_Goal;
  /// The result message defined in the action definition.
  using Result = psdk_interfaces::action::CameraDeleteFileByIndex_Result;
  /// The feedback message defined in the action definition.
  using Feedback = psdk_interfaces::action::CameraDeleteFileByIndex_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = psdk_interfaces::action::CameraDeleteFileByIndex_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct CameraDeleteFileByIndex CameraDeleteFileByIndex;

}  // namespace action

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__STRUCT_HPP_
