// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:action/CameraDeleteFileByIndex.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__TRAITS_HPP_
#define PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/action/detail/camera_delete_file_by_index__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: payload_index
  {
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << ", ";
  }

  // member: file_index
  {
    out << "file_index: ";
    rosidl_generator_traits::value_to_yaml(msg.file_index, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: payload_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << "\n";
  }

  // member: file_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "file_index: ";
    rosidl_generator_traits::value_to_yaml(msg.file_index, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_Goal & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_Goal";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_Goal";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_Result & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_Result>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_Result";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_Result>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_Result";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_Result>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_Result>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_Feedback & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_Feedback & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_Feedback";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_Feedback";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "psdk_interfaces/action/detail/camera_delete_file_by_index__traits.hpp"

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_SendGoal_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_SendGoal_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_SendGoal";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>::value &&
    has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>::value &&
    has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::action::CameraDeleteFileByIndex_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_GetResult_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__traits.hpp"

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_GetResult_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_Result>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_Result>::value> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_GetResult";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_GetResult";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>::value &&
    has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>::value &&
    has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::action::CameraDeleteFileByIndex_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "psdk_interfaces/action/detail/camera_delete_file_by_index__traits.hpp"

namespace psdk_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const CameraDeleteFileByIndex_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDeleteFileByIndex_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDeleteFileByIndex_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage & msg)
{
  return psdk_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage>()
{
  return "psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage";
}

template<>
inline const char * name<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage>()
{
  return "psdk_interfaces/action/CameraDeleteFileByIndex_FeedbackMessage";
}

template<>
struct has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<psdk_interfaces::action::CameraDeleteFileByIndex_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<psdk_interfaces::action::CameraDeleteFileByIndex>
  : std::true_type
{
};

template<>
struct is_action_goal<psdk_interfaces::action::CameraDeleteFileByIndex_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<psdk_interfaces::action::CameraDeleteFileByIndex_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<psdk_interfaces::action::CameraDeleteFileByIndex_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DELETE_FILE_BY_INDEX__TRAITS_HPP_
