// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from psdk_interfaces:action/CameraDownloadFileByIndex.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DOWNLOAD_FILE_BY_INDEX__FUNCTIONS_H_
#define PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DOWNLOAD_FILE_BY_INDEX__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "psdk_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "psdk_interfaces/action/detail/camera_download_file_by_index__struct.h"

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__init(psdk_interfaces__action__CameraDownloadFileByIndex_Goal * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__fini(psdk_interfaces__action__CameraDownloadFileByIndex_Goal * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_Goal *
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_Goal * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_Goal * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_Goal * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_Goal * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_Goal * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_Goal__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Result__init(psdk_interfaces__action__CameraDownloadFileByIndex_Result * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Result__fini(psdk_interfaces__action__CameraDownloadFileByIndex_Result * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_Result *
psdk_interfaces__action__CameraDownloadFileByIndex_Result__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Result__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_Result * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Result__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_Result * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_Result * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Result__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_Result * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_Result * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_Result__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__init(psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__fini(psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback *
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_Feedback * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_Feedback__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__init(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__fini(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request *
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Request__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__init(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__fini(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response *
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_SendGoal_Response__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__init(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__fini(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request *
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Request__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__init(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__fini(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response *
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_GetResult_Response__Sequence * output);

/// Initialize action/CameraDownloadFileByIndex message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage
 * )) before or use
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__init(psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * msg);

/// Finalize action/CameraDownloadFileByIndex message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__fini(psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * msg);

/// Create action/CameraDownloadFileByIndex message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage *
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__create();

/// Destroy action/CameraDownloadFileByIndex message.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * msg);

/// Check for action/CameraDownloadFileByIndex message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * rhs);

/// Copy a action/CameraDownloadFileByIndex message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage * output);

/// Initialize array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__init(psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * array, size_t size);

/// Finalize array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__fini(psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * array);

/// Create array of action/CameraDownloadFileByIndex messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence *
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__create(size_t size);

/// Destroy array of action/CameraDownloadFileByIndex messages.
/**
 * It calls
 * psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__destroy(psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * array);

/// Check for action/CameraDownloadFileByIndex message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__are_equal(const psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * lhs, const psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * rhs);

/// Copy an array of action/CameraDownloadFileByIndex messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence__copy(
  const psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * input,
  psdk_interfaces__action__CameraDownloadFileByIndex_FeedbackMessage__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__ACTION__DETAIL__CAMERA_DOWNLOAD_FILE_BY_INDEX__FUNCTIONS_H_
