// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/EscData.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__ESC_DATA__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__ESC_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'esc'
#include "psdk_interfaces/msg/detail/esc_status_individual__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__EscData __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__EscData __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EscData_
{
  using Type = EscData_<ContainerAllocator>;

  explicit EscData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit EscData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _esc_type =
    std::vector<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>>;
  _esc_type esc;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__esc(
    const std::vector<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<psdk_interfaces::msg::EscStatusIndividual_<ContainerAllocator>>> & _arg)
  {
    this->esc = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::EscData_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::EscData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::EscData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::EscData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__EscData
    std::shared_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__EscData
    std::shared_ptr<psdk_interfaces::msg::EscData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EscData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->esc != other.esc) {
      return false;
    }
    return true;
  }
  bool operator!=(const EscData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EscData_

// alias to use template instance with default allocator
using EscData =
  psdk_interfaces::msg::EscData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__ESC_DATA__STRUCT_HPP_
