// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/FileAttributes.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/file_attributes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
psdk_interfaces__msg__FileAttributes__init(psdk_interfaces__msg__FileAttributes * msg)
{
  if (!msg) {
    return false;
  }
  // photo_ratio
  // photo_rotation
  // video_duration
  // video_frame_rate
  // video_rotation
  // video_resolution
  return true;
}

void
psdk_interfaces__msg__FileAttributes__fini(psdk_interfaces__msg__FileAttributes * msg)
{
  if (!msg) {
    return;
  }
  // photo_ratio
  // photo_rotation
  // video_duration
  // video_frame_rate
  // video_rotation
  // video_resolution
}

bool
psdk_interfaces__msg__FileAttributes__are_equal(const psdk_interfaces__msg__FileAttributes * lhs, const psdk_interfaces__msg__FileAttributes * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // photo_ratio
  if (lhs->photo_ratio != rhs->photo_ratio) {
    return false;
  }
  // photo_rotation
  if (lhs->photo_rotation != rhs->photo_rotation) {
    return false;
  }
  // video_duration
  if (lhs->video_duration != rhs->video_duration) {
    return false;
  }
  // video_frame_rate
  if (lhs->video_frame_rate != rhs->video_frame_rate) {
    return false;
  }
  // video_rotation
  if (lhs->video_rotation != rhs->video_rotation) {
    return false;
  }
  // video_resolution
  if (lhs->video_resolution != rhs->video_resolution) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__FileAttributes__copy(
  const psdk_interfaces__msg__FileAttributes * input,
  psdk_interfaces__msg__FileAttributes * output)
{
  if (!input || !output) {
    return false;
  }
  // photo_ratio
  output->photo_ratio = input->photo_ratio;
  // photo_rotation
  output->photo_rotation = input->photo_rotation;
  // video_duration
  output->video_duration = input->video_duration;
  // video_frame_rate
  output->video_frame_rate = input->video_frame_rate;
  // video_rotation
  output->video_rotation = input->video_rotation;
  // video_resolution
  output->video_resolution = input->video_resolution;
  return true;
}

psdk_interfaces__msg__FileAttributes *
psdk_interfaces__msg__FileAttributes__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__FileAttributes * msg = (psdk_interfaces__msg__FileAttributes *)allocator.allocate(sizeof(psdk_interfaces__msg__FileAttributes), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__FileAttributes));
  bool success = psdk_interfaces__msg__FileAttributes__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__FileAttributes__destroy(psdk_interfaces__msg__FileAttributes * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__FileAttributes__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__FileAttributes__Sequence__init(psdk_interfaces__msg__FileAttributes__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__FileAttributes * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__FileAttributes *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__FileAttributes), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__FileAttributes__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__FileAttributes__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__FileAttributes__Sequence__fini(psdk_interfaces__msg__FileAttributes__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__FileAttributes__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__FileAttributes__Sequence *
psdk_interfaces__msg__FileAttributes__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__FileAttributes__Sequence * array = (psdk_interfaces__msg__FileAttributes__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__FileAttributes__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__FileAttributes__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__FileAttributes__Sequence__destroy(psdk_interfaces__msg__FileAttributes__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__FileAttributes__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__FileAttributes__Sequence__are_equal(const psdk_interfaces__msg__FileAttributes__Sequence * lhs, const psdk_interfaces__msg__FileAttributes__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__FileAttributes__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__FileAttributes__Sequence__copy(
  const psdk_interfaces__msg__FileAttributes__Sequence * input,
  psdk_interfaces__msg__FileAttributes__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__FileAttributes);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__FileAttributes * data =
      (psdk_interfaces__msg__FileAttributes *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__FileAttributes__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__FileAttributes__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__FileAttributes__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
