// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/FileAttributes.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FILE_ATTRIBUTES__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FILE_ATTRIBUTES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/file_attributes__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FileAttributes & msg,
  std::ostream & out)
{
  out << "{";
  // member: photo_ratio
  {
    out << "photo_ratio: ";
    rosidl_generator_traits::value_to_yaml(msg.photo_ratio, out);
    out << ", ";
  }

  // member: photo_rotation
  {
    out << "photo_rotation: ";
    rosidl_generator_traits::value_to_yaml(msg.photo_rotation, out);
    out << ", ";
  }

  // member: video_duration
  {
    out << "video_duration: ";
    rosidl_generator_traits::value_to_yaml(msg.video_duration, out);
    out << ", ";
  }

  // member: video_frame_rate
  {
    out << "video_frame_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.video_frame_rate, out);
    out << ", ";
  }

  // member: video_rotation
  {
    out << "video_rotation: ";
    rosidl_generator_traits::value_to_yaml(msg.video_rotation, out);
    out << ", ";
  }

  // member: video_resolution
  {
    out << "video_resolution: ";
    rosidl_generator_traits::value_to_yaml(msg.video_resolution, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FileAttributes & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: photo_ratio
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "photo_ratio: ";
    rosidl_generator_traits::value_to_yaml(msg.photo_ratio, out);
    out << "\n";
  }

  // member: photo_rotation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "photo_rotation: ";
    rosidl_generator_traits::value_to_yaml(msg.photo_rotation, out);
    out << "\n";
  }

  // member: video_duration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "video_duration: ";
    rosidl_generator_traits::value_to_yaml(msg.video_duration, out);
    out << "\n";
  }

  // member: video_frame_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "video_frame_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.video_frame_rate, out);
    out << "\n";
  }

  // member: video_rotation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "video_rotation: ";
    rosidl_generator_traits::value_to_yaml(msg.video_rotation, out);
    out << "\n";
  }

  // member: video_resolution
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "video_resolution: ";
    rosidl_generator_traits::value_to_yaml(msg.video_resolution, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FileAttributes & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::FileAttributes & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::FileAttributes & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::FileAttributes>()
{
  return "psdk_interfaces::msg::FileAttributes";
}

template<>
inline const char * name<psdk_interfaces::msg::FileAttributes>()
{
  return "psdk_interfaces/msg/FileAttributes";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::FileAttributes>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::FileAttributes>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::msg::FileAttributes>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__FILE_ATTRIBUTES__TRAITS_HPP_
