// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/FileInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FILE_INFO__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FILE_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'attributes'
#include "psdk_interfaces/msg/detail/file_attributes__struct.hpp"
// Member 'sub_files'
#include "psdk_interfaces/msg/detail/sub_file_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__FileInfo __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__FileInfo __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FileInfo_
{
  using Type = FileInfo_<ContainerAllocator>;

  explicit FileInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : attributes(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->type = 0;
      this->size = 0ul;
      this->index = 0ul;
      this->create_time_unix = 0ll;
      this->number_sub_files = 0;
    }
  }

  explicit FileInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc),
    attributes(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->type = 0;
      this->size = 0ul;
      this->index = 0ul;
      this->create_time_unix = 0ll;
      this->number_sub_files = 0;
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _type_type =
    uint8_t;
  _type_type type;
  using _size_type =
    uint32_t;
  _size_type size;
  using _index_type =
    uint32_t;
  _index_type index;
  using _create_time_unix_type =
    int64_t;
  _create_time_unix_type create_time_unix;
  using _attributes_type =
    psdk_interfaces::msg::FileAttributes_<ContainerAllocator>;
  _attributes_type attributes;
  using _number_sub_files_type =
    uint8_t;
  _number_sub_files_type number_sub_files;
  using _sub_files_type =
    std::vector<psdk_interfaces::msg::SubFileInfo_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<psdk_interfaces::msg::SubFileInfo_<ContainerAllocator>>>;
  _sub_files_type sub_files;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__type(
    const uint8_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__size(
    const uint32_t & _arg)
  {
    this->size = _arg;
    return *this;
  }
  Type & set__index(
    const uint32_t & _arg)
  {
    this->index = _arg;
    return *this;
  }
  Type & set__create_time_unix(
    const int64_t & _arg)
  {
    this->create_time_unix = _arg;
    return *this;
  }
  Type & set__attributes(
    const psdk_interfaces::msg::FileAttributes_<ContainerAllocator> & _arg)
  {
    this->attributes = _arg;
    return *this;
  }
  Type & set__number_sub_files(
    const uint8_t & _arg)
  {
    this->number_sub_files = _arg;
    return *this;
  }
  Type & set__sub_files(
    const std::vector<psdk_interfaces::msg::SubFileInfo_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<psdk_interfaces::msg::SubFileInfo_<ContainerAllocator>>> & _arg)
  {
    this->sub_files = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::FileInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::FileInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FileInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FileInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__FileInfo
    std::shared_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__FileInfo
    std::shared_ptr<psdk_interfaces::msg::FileInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FileInfo_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->size != other.size) {
      return false;
    }
    if (this->index != other.index) {
      return false;
    }
    if (this->create_time_unix != other.create_time_unix) {
      return false;
    }
    if (this->attributes != other.attributes) {
      return false;
    }
    if (this->number_sub_files != other.number_sub_files) {
      return false;
    }
    if (this->sub_files != other.sub_files) {
      return false;
    }
    return true;
  }
  bool operator!=(const FileInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FileInfo_

// alias to use template instance with default allocator
using FileInfo =
  psdk_interfaces::msg::FileInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__FILE_INFO__STRUCT_HPP_
