// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/FileInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FILE_INFO__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FILE_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/file_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'attributes'
#include "psdk_interfaces/msg/detail/file_attributes__traits.hpp"
// Member 'sub_files'
#include "psdk_interfaces/msg/detail/sub_file_info__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FileInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: size
  {
    out << "size: ";
    rosidl_generator_traits::value_to_yaml(msg.size, out);
    out << ", ";
  }

  // member: index
  {
    out << "index: ";
    rosidl_generator_traits::value_to_yaml(msg.index, out);
    out << ", ";
  }

  // member: create_time_unix
  {
    out << "create_time_unix: ";
    rosidl_generator_traits::value_to_yaml(msg.create_time_unix, out);
    out << ", ";
  }

  // member: attributes
  {
    out << "attributes: ";
    to_flow_style_yaml(msg.attributes, out);
    out << ", ";
  }

  // member: number_sub_files
  {
    out << "number_sub_files: ";
    rosidl_generator_traits::value_to_yaml(msg.number_sub_files, out);
    out << ", ";
  }

  // member: sub_files
  {
    if (msg.sub_files.size() == 0) {
      out << "sub_files: []";
    } else {
      out << "sub_files: [";
      size_t pending_items = msg.sub_files.size();
      for (auto item : msg.sub_files) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FileInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "size: ";
    rosidl_generator_traits::value_to_yaml(msg.size, out);
    out << "\n";
  }

  // member: index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "index: ";
    rosidl_generator_traits::value_to_yaml(msg.index, out);
    out << "\n";
  }

  // member: create_time_unix
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "create_time_unix: ";
    rosidl_generator_traits::value_to_yaml(msg.create_time_unix, out);
    out << "\n";
  }

  // member: attributes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "attributes:\n";
    to_block_style_yaml(msg.attributes, out, indentation + 2);
  }

  // member: number_sub_files
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_sub_files: ";
    rosidl_generator_traits::value_to_yaml(msg.number_sub_files, out);
    out << "\n";
  }

  // member: sub_files
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.sub_files.size() == 0) {
      out << "sub_files: []\n";
    } else {
      out << "sub_files:\n";
      for (auto item : msg.sub_files) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FileInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::FileInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::FileInfo & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::FileInfo>()
{
  return "psdk_interfaces::msg::FileInfo";
}

template<>
inline const char * name<psdk_interfaces::msg::FileInfo>()
{
  return "psdk_interfaces/msg/FileInfo";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::FileInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::FileInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<psdk_interfaces::msg::FileInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__FILE_INFO__TRAITS_HPP_
