// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/GimbalStatus.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/gimbal_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
psdk_interfaces__msg__GimbalStatus__init(psdk_interfaces__msg__GimbalStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__GimbalStatus__fini(msg);
    return false;
  }
  // mount_status
  // is_busy
  // pitch_limited
  // roll_limited
  // yaw_limited
  // calibrating
  // prev_calibration_result
  // installed_direction
  // disabled_mvo
  // gear_show_unable
  // gyro_falut
  // esc_pitch_status
  // esc_roll_status
  // esc_yaw_status
  // drone_data_recv
  // init_unfinished
  // fw_updating
  return true;
}

void
psdk_interfaces__msg__GimbalStatus__fini(psdk_interfaces__msg__GimbalStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // mount_status
  // is_busy
  // pitch_limited
  // roll_limited
  // yaw_limited
  // calibrating
  // prev_calibration_result
  // installed_direction
  // disabled_mvo
  // gear_show_unable
  // gyro_falut
  // esc_pitch_status
  // esc_roll_status
  // esc_yaw_status
  // drone_data_recv
  // init_unfinished
  // fw_updating
}

bool
psdk_interfaces__msg__GimbalStatus__are_equal(const psdk_interfaces__msg__GimbalStatus * lhs, const psdk_interfaces__msg__GimbalStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // mount_status
  if (lhs->mount_status != rhs->mount_status) {
    return false;
  }
  // is_busy
  if (lhs->is_busy != rhs->is_busy) {
    return false;
  }
  // pitch_limited
  if (lhs->pitch_limited != rhs->pitch_limited) {
    return false;
  }
  // roll_limited
  if (lhs->roll_limited != rhs->roll_limited) {
    return false;
  }
  // yaw_limited
  if (lhs->yaw_limited != rhs->yaw_limited) {
    return false;
  }
  // calibrating
  if (lhs->calibrating != rhs->calibrating) {
    return false;
  }
  // prev_calibration_result
  if (lhs->prev_calibration_result != rhs->prev_calibration_result) {
    return false;
  }
  // installed_direction
  if (lhs->installed_direction != rhs->installed_direction) {
    return false;
  }
  // disabled_mvo
  if (lhs->disabled_mvo != rhs->disabled_mvo) {
    return false;
  }
  // gear_show_unable
  if (lhs->gear_show_unable != rhs->gear_show_unable) {
    return false;
  }
  // gyro_falut
  if (lhs->gyro_falut != rhs->gyro_falut) {
    return false;
  }
  // esc_pitch_status
  if (lhs->esc_pitch_status != rhs->esc_pitch_status) {
    return false;
  }
  // esc_roll_status
  if (lhs->esc_roll_status != rhs->esc_roll_status) {
    return false;
  }
  // esc_yaw_status
  if (lhs->esc_yaw_status != rhs->esc_yaw_status) {
    return false;
  }
  // drone_data_recv
  if (lhs->drone_data_recv != rhs->drone_data_recv) {
    return false;
  }
  // init_unfinished
  if (lhs->init_unfinished != rhs->init_unfinished) {
    return false;
  }
  // fw_updating
  if (lhs->fw_updating != rhs->fw_updating) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__GimbalStatus__copy(
  const psdk_interfaces__msg__GimbalStatus * input,
  psdk_interfaces__msg__GimbalStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // mount_status
  output->mount_status = input->mount_status;
  // is_busy
  output->is_busy = input->is_busy;
  // pitch_limited
  output->pitch_limited = input->pitch_limited;
  // roll_limited
  output->roll_limited = input->roll_limited;
  // yaw_limited
  output->yaw_limited = input->yaw_limited;
  // calibrating
  output->calibrating = input->calibrating;
  // prev_calibration_result
  output->prev_calibration_result = input->prev_calibration_result;
  // installed_direction
  output->installed_direction = input->installed_direction;
  // disabled_mvo
  output->disabled_mvo = input->disabled_mvo;
  // gear_show_unable
  output->gear_show_unable = input->gear_show_unable;
  // gyro_falut
  output->gyro_falut = input->gyro_falut;
  // esc_pitch_status
  output->esc_pitch_status = input->esc_pitch_status;
  // esc_roll_status
  output->esc_roll_status = input->esc_roll_status;
  // esc_yaw_status
  output->esc_yaw_status = input->esc_yaw_status;
  // drone_data_recv
  output->drone_data_recv = input->drone_data_recv;
  // init_unfinished
  output->init_unfinished = input->init_unfinished;
  // fw_updating
  output->fw_updating = input->fw_updating;
  return true;
}

psdk_interfaces__msg__GimbalStatus *
psdk_interfaces__msg__GimbalStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__GimbalStatus * msg = (psdk_interfaces__msg__GimbalStatus *)allocator.allocate(sizeof(psdk_interfaces__msg__GimbalStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__GimbalStatus));
  bool success = psdk_interfaces__msg__GimbalStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__GimbalStatus__destroy(psdk_interfaces__msg__GimbalStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__GimbalStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__GimbalStatus__Sequence__init(psdk_interfaces__msg__GimbalStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__GimbalStatus * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__GimbalStatus *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__GimbalStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__GimbalStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__GimbalStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__GimbalStatus__Sequence__fini(psdk_interfaces__msg__GimbalStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__GimbalStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__GimbalStatus__Sequence *
psdk_interfaces__msg__GimbalStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__GimbalStatus__Sequence * array = (psdk_interfaces__msg__GimbalStatus__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__GimbalStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__GimbalStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__GimbalStatus__Sequence__destroy(psdk_interfaces__msg__GimbalStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__GimbalStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__GimbalStatus__Sequence__are_equal(const psdk_interfaces__msg__GimbalStatus__Sequence * lhs, const psdk_interfaces__msg__GimbalStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__GimbalStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__GimbalStatus__Sequence__copy(
  const psdk_interfaces__msg__GimbalStatus__Sequence * input,
  psdk_interfaces__msg__GimbalStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__GimbalStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__GimbalStatus * data =
      (psdk_interfaces__msg__GimbalStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__GimbalStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__GimbalStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__GimbalStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
