// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/GPSDetails.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__GPSDetails __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__GPSDetails __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GPSDetails_
{
  using Type = GPSDetails_<ContainerAllocator>;

  explicit GPSDetails_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->horizontal_dop = 0.0f;
      this->position_dop = 0.0f;
      this->fix_state = 0.0f;
      this->vertical_accuracy = 0.0f;
      this->horizontal_accuracy = 0.0f;
      this->speed_accuracy = 0.0f;
      this->num_gps_satellites_used = 0ul;
      this->num_glonass_satellites_used = 0ul;
      this->num_total_satellites_used = 0;
      this->gps_counter = 0;
    }
  }

  explicit GPSDetails_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->horizontal_dop = 0.0f;
      this->position_dop = 0.0f;
      this->fix_state = 0.0f;
      this->vertical_accuracy = 0.0f;
      this->horizontal_accuracy = 0.0f;
      this->speed_accuracy = 0.0f;
      this->num_gps_satellites_used = 0ul;
      this->num_glonass_satellites_used = 0ul;
      this->num_total_satellites_used = 0;
      this->gps_counter = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _horizontal_dop_type =
    float;
  _horizontal_dop_type horizontal_dop;
  using _position_dop_type =
    float;
  _position_dop_type position_dop;
  using _fix_state_type =
    float;
  _fix_state_type fix_state;
  using _vertical_accuracy_type =
    float;
  _vertical_accuracy_type vertical_accuracy;
  using _horizontal_accuracy_type =
    float;
  _horizontal_accuracy_type horizontal_accuracy;
  using _speed_accuracy_type =
    float;
  _speed_accuracy_type speed_accuracy;
  using _num_gps_satellites_used_type =
    uint32_t;
  _num_gps_satellites_used_type num_gps_satellites_used;
  using _num_glonass_satellites_used_type =
    uint32_t;
  _num_glonass_satellites_used_type num_glonass_satellites_used;
  using _num_total_satellites_used_type =
    uint16_t;
  _num_total_satellites_used_type num_total_satellites_used;
  using _gps_counter_type =
    uint16_t;
  _gps_counter_type gps_counter;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__horizontal_dop(
    const float & _arg)
  {
    this->horizontal_dop = _arg;
    return *this;
  }
  Type & set__position_dop(
    const float & _arg)
  {
    this->position_dop = _arg;
    return *this;
  }
  Type & set__fix_state(
    const float & _arg)
  {
    this->fix_state = _arg;
    return *this;
  }
  Type & set__vertical_accuracy(
    const float & _arg)
  {
    this->vertical_accuracy = _arg;
    return *this;
  }
  Type & set__horizontal_accuracy(
    const float & _arg)
  {
    this->horizontal_accuracy = _arg;
    return *this;
  }
  Type & set__speed_accuracy(
    const float & _arg)
  {
    this->speed_accuracy = _arg;
    return *this;
  }
  Type & set__num_gps_satellites_used(
    const uint32_t & _arg)
  {
    this->num_gps_satellites_used = _arg;
    return *this;
  }
  Type & set__num_glonass_satellites_used(
    const uint32_t & _arg)
  {
    this->num_glonass_satellites_used = _arg;
    return *this;
  }
  Type & set__num_total_satellites_used(
    const uint16_t & _arg)
  {
    this->num_total_satellites_used = _arg;
    return *this;
  }
  Type & set__gps_counter(
    const uint16_t & _arg)
  {
    this->gps_counter = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t GPS_FIX_STATE_NO_FIX =
    0u;
  static constexpr uint16_t GPS_FIX_STATE_DEAD_RECKONING_ONLY =
    1u;
  static constexpr uint16_t GPS_FIX_STATE_2D_FIX =
    2u;
  static constexpr uint16_t GPS_FIX_STATE_3D_FIX =
    3u;
  static constexpr uint16_t GPS_FIX_STATE_GPS_PLUS_DEAD_RECKONING =
    4u;
  static constexpr uint16_t GPS_FIX_STATE_TIME_ONLY_FIX =
    5u;

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::GPSDetails_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::GPSDetails_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::GPSDetails_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::GPSDetails_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__GPSDetails
    std::shared_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__GPSDetails
    std::shared_ptr<psdk_interfaces::msg::GPSDetails_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GPSDetails_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->horizontal_dop != other.horizontal_dop) {
      return false;
    }
    if (this->position_dop != other.position_dop) {
      return false;
    }
    if (this->fix_state != other.fix_state) {
      return false;
    }
    if (this->vertical_accuracy != other.vertical_accuracy) {
      return false;
    }
    if (this->horizontal_accuracy != other.horizontal_accuracy) {
      return false;
    }
    if (this->speed_accuracy != other.speed_accuracy) {
      return false;
    }
    if (this->num_gps_satellites_used != other.num_gps_satellites_used) {
      return false;
    }
    if (this->num_glonass_satellites_used != other.num_glonass_satellites_used) {
      return false;
    }
    if (this->num_total_satellites_used != other.num_total_satellites_used) {
      return false;
    }
    if (this->gps_counter != other.gps_counter) {
      return false;
    }
    return true;
  }
  bool operator!=(const GPSDetails_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GPSDetails_

// alias to use template instance with default allocator
using GPSDetails =
  psdk_interfaces::msg::GPSDetails_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSDetails_<ContainerAllocator>::GPS_FIX_STATE_NO_FIX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSDetails_<ContainerAllocator>::GPS_FIX_STATE_DEAD_RECKONING_ONLY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSDetails_<ContainerAllocator>::GPS_FIX_STATE_2D_FIX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSDetails_<ContainerAllocator>::GPS_FIX_STATE_3D_FIX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSDetails_<ContainerAllocator>::GPS_FIX_STATE_GPS_PLUS_DEAD_RECKONING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSDetails_<ContainerAllocator>::GPS_FIX_STATE_TIME_ONLY_FIX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__GPS_DETAILS__STRUCT_HPP_
