// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/HmsInfoMsg.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/hms_info_msg__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ground_info`
// Member `fly_info`
#include "rosidl_runtime_c/string_functions.h"

bool
psdk_interfaces__msg__HmsInfoMsg__init(psdk_interfaces__msg__HmsInfoMsg * msg)
{
  if (!msg) {
    return false;
  }
  // error_code
  // component_index
  // error_level
  // ground_info
  if (!rosidl_runtime_c__String__init(&msg->ground_info)) {
    psdk_interfaces__msg__HmsInfoMsg__fini(msg);
    return false;
  }
  // fly_info
  if (!rosidl_runtime_c__String__init(&msg->fly_info)) {
    psdk_interfaces__msg__HmsInfoMsg__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__msg__HmsInfoMsg__fini(psdk_interfaces__msg__HmsInfoMsg * msg)
{
  if (!msg) {
    return;
  }
  // error_code
  // component_index
  // error_level
  // ground_info
  rosidl_runtime_c__String__fini(&msg->ground_info);
  // fly_info
  rosidl_runtime_c__String__fini(&msg->fly_info);
}

bool
psdk_interfaces__msg__HmsInfoMsg__are_equal(const psdk_interfaces__msg__HmsInfoMsg * lhs, const psdk_interfaces__msg__HmsInfoMsg * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // error_code
  if (lhs->error_code != rhs->error_code) {
    return false;
  }
  // component_index
  if (lhs->component_index != rhs->component_index) {
    return false;
  }
  // error_level
  if (lhs->error_level != rhs->error_level) {
    return false;
  }
  // ground_info
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->ground_info), &(rhs->ground_info)))
  {
    return false;
  }
  // fly_info
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->fly_info), &(rhs->fly_info)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__HmsInfoMsg__copy(
  const psdk_interfaces__msg__HmsInfoMsg * input,
  psdk_interfaces__msg__HmsInfoMsg * output)
{
  if (!input || !output) {
    return false;
  }
  // error_code
  output->error_code = input->error_code;
  // component_index
  output->component_index = input->component_index;
  // error_level
  output->error_level = input->error_level;
  // ground_info
  if (!rosidl_runtime_c__String__copy(
      &(input->ground_info), &(output->ground_info)))
  {
    return false;
  }
  // fly_info
  if (!rosidl_runtime_c__String__copy(
      &(input->fly_info), &(output->fly_info)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__msg__HmsInfoMsg *
psdk_interfaces__msg__HmsInfoMsg__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__HmsInfoMsg * msg = (psdk_interfaces__msg__HmsInfoMsg *)allocator.allocate(sizeof(psdk_interfaces__msg__HmsInfoMsg), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__HmsInfoMsg));
  bool success = psdk_interfaces__msg__HmsInfoMsg__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__HmsInfoMsg__destroy(psdk_interfaces__msg__HmsInfoMsg * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__HmsInfoMsg__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__HmsInfoMsg__Sequence__init(psdk_interfaces__msg__HmsInfoMsg__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__HmsInfoMsg * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__HmsInfoMsg *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__HmsInfoMsg), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__HmsInfoMsg__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__HmsInfoMsg__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__HmsInfoMsg__Sequence__fini(psdk_interfaces__msg__HmsInfoMsg__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__HmsInfoMsg__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__HmsInfoMsg__Sequence *
psdk_interfaces__msg__HmsInfoMsg__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__HmsInfoMsg__Sequence * array = (psdk_interfaces__msg__HmsInfoMsg__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__HmsInfoMsg__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__HmsInfoMsg__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__HmsInfoMsg__Sequence__destroy(psdk_interfaces__msg__HmsInfoMsg__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__HmsInfoMsg__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__HmsInfoMsg__Sequence__are_equal(const psdk_interfaces__msg__HmsInfoMsg__Sequence * lhs, const psdk_interfaces__msg__HmsInfoMsg__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__HmsInfoMsg__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__HmsInfoMsg__Sequence__copy(
  const psdk_interfaces__msg__HmsInfoMsg__Sequence * input,
  psdk_interfaces__msg__HmsInfoMsg__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__HmsInfoMsg);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__HmsInfoMsg * data =
      (psdk_interfaces__msg__HmsInfoMsg *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__HmsInfoMsg__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__HmsInfoMsg__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__HmsInfoMsg__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
