// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/HmsInfoMsg.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN_HMS_ERROR_LEVEL'.
enum
{
  psdk_interfaces__msg__HmsInfoMsg__MIN_HMS_ERROR_LEVEL = 0
};

/// Constant 'MID_HMS_ERROR_LEVEL'.
enum
{
  psdk_interfaces__msg__HmsInfoMsg__MID_HMS_ERROR_LEVEL = 3
};

/// Constant 'MAX_HMS_ERROR_LEVEL'.
enum
{
  psdk_interfaces__msg__HmsInfoMsg__MAX_HMS_ERROR_LEVEL = 6
};

// Include directives for member types
// Member 'ground_info'
// Member 'fly_info'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/HmsInfoMsg in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__HmsInfoMsg
{
  /// Error code associated to HMS message
  uint32_t error_code;
  /// Related to "payloadId" in the camera module
  uint8_t component_index;
  uint8_t error_level;
  /// Description of the error code if/when the drone is on the ground
  rosidl_runtime_c__String ground_info;
  /// Description of the error code if/when the drone is in the air
  rosidl_runtime_c__String fly_info;
} psdk_interfaces__msg__HmsInfoMsg;

// Struct for a sequence of psdk_interfaces__msg__HmsInfoMsg.
typedef struct psdk_interfaces__msg__HmsInfoMsg__Sequence
{
  psdk_interfaces__msg__HmsInfoMsg * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__HmsInfoMsg__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__HMS_INFO_MSG__STRUCT_H_
