// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/HomePosition.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__HOME_POSITION__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__HOME_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__HomePosition __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__HomePosition __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HomePosition_
{
  using Type = HomePosition_<ContainerAllocator>;

  explicit HomePosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->home_position_status = 0;
      this->latitude = 0.0;
      this->longitude = 0.0;
    }
  }

  explicit HomePosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->home_position_status = 0;
      this->latitude = 0.0;
      this->longitude = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _home_position_status_type =
    uint8_t;
  _home_position_status_type home_position_status;
  using _latitude_type =
    double;
  _latitude_type latitude;
  using _longitude_type =
    double;
  _longitude_type longitude;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__home_position_status(
    const uint8_t & _arg)
  {
    this->home_position_status = _arg;
    return *this;
  }
  Type & set__latitude(
    const double & _arg)
  {
    this->latitude = _arg;
    return *this;
  }
  Type & set__longitude(
    const double & _arg)
  {
    this->longitude = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t HOME_POSITION_STATUS_FAILED =
    0u;
  static constexpr uint8_t HOME_POSITION_STATUS_SUCCESS =
    1u;

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::HomePosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::HomePosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::HomePosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::HomePosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__HomePosition
    std::shared_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__HomePosition
    std::shared_ptr<psdk_interfaces::msg::HomePosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HomePosition_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->home_position_status != other.home_position_status) {
      return false;
    }
    if (this->latitude != other.latitude) {
      return false;
    }
    if (this->longitude != other.longitude) {
      return false;
    }
    return true;
  }
  bool operator!=(const HomePosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HomePosition_

// alias to use template instance with default allocator
using HomePosition =
  psdk_interfaces::msg::HomePosition_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HomePosition_<ContainerAllocator>::HOME_POSITION_STATUS_FAILED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HomePosition_<ContainerAllocator>::HOME_POSITION_STATUS_SUCCESS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__HOME_POSITION__STRUCT_HPP_
