// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/PositionFused.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__POSITION_FUSED__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__POSITION_FUSED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/position_fused__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const PositionFused & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    to_flow_style_yaml(msg.position, out);
    out << ", ";
  }

  // member: x_health
  {
    out << "x_health: ";
    rosidl_generator_traits::value_to_yaml(msg.x_health, out);
    out << ", ";
  }

  // member: y_health
  {
    out << "y_health: ";
    rosidl_generator_traits::value_to_yaml(msg.y_health, out);
    out << ", ";
  }

  // member: z_health
  {
    out << "z_health: ";
    rosidl_generator_traits::value_to_yaml(msg.z_health, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PositionFused & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_block_style_yaml(msg.position, out, indentation + 2);
  }

  // member: x_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x_health: ";
    rosidl_generator_traits::value_to_yaml(msg.x_health, out);
    out << "\n";
  }

  // member: y_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y_health: ";
    rosidl_generator_traits::value_to_yaml(msg.y_health, out);
    out << "\n";
  }

  // member: z_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_health: ";
    rosidl_generator_traits::value_to_yaml(msg.z_health, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PositionFused & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::PositionFused & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::PositionFused & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::PositionFused>()
{
  return "psdk_interfaces::msg::PositionFused";
}

template<>
inline const char * name<psdk_interfaces::msg::PositionFused>()
{
  return "psdk_interfaces/msg/PositionFused";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::PositionFused>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::PositionFused>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::PositionFused>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__POSITION_FUSED__TRAITS_HPP_
