// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/RCConnectionStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__RCConnectionStatus __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__RCConnectionStatus __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RCConnectionStatus_
{
  using Type = RCConnectionStatus_<ContainerAllocator>;

  explicit RCConnectionStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->air_connection = 0;
      this->ground_connection = 0;
      this->app_connection = 0;
      this->air_or_ground_disconnected = 0;
    }
  }

  explicit RCConnectionStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->air_connection = 0;
      this->ground_connection = 0;
      this->app_connection = 0;
      this->air_or_ground_disconnected = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _air_connection_type =
    uint8_t;
  _air_connection_type air_connection;
  using _ground_connection_type =
    uint8_t;
  _ground_connection_type ground_connection;
  using _app_connection_type =
    uint8_t;
  _app_connection_type app_connection;
  using _air_or_ground_disconnected_type =
    uint8_t;
  _air_or_ground_disconnected_type air_or_ground_disconnected;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__air_connection(
    const uint8_t & _arg)
  {
    this->air_connection = _arg;
    return *this;
  }
  Type & set__ground_connection(
    const uint8_t & _arg)
  {
    this->ground_connection = _arg;
    return *this;
  }
  Type & set__app_connection(
    const uint8_t & _arg)
  {
    this->app_connection = _arg;
    return *this;
  }
  Type & set__air_or_ground_disconnected(
    const uint8_t & _arg)
  {
    this->air_or_ground_disconnected = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__RCConnectionStatus
    std::shared_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__RCConnectionStatus
    std::shared_ptr<psdk_interfaces::msg::RCConnectionStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RCConnectionStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->air_connection != other.air_connection) {
      return false;
    }
    if (this->ground_connection != other.ground_connection) {
      return false;
    }
    if (this->app_connection != other.app_connection) {
      return false;
    }
    if (this->air_or_ground_disconnected != other.air_or_ground_disconnected) {
      return false;
    }
    return true;
  }
  bool operator!=(const RCConnectionStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RCConnectionStatus_

// alias to use template instance with default allocator
using RCConnectionStatus =
  psdk_interfaces::msg::RCConnectionStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__STRUCT_HPP_
