// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/RelativeObstacleInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/RelativeObstacleInfo in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__RelativeObstacleInfo
{
  std_msgs__msg__Header header;
  /// distance from obstacle (m)
  float down;
  /// distance from obstacle (m)
  float front;
  /// distance from obstacle (m)
  float right;
  /// distance from obstacle (m)
  float back;
  /// distance from obstacle (m)
  float left;
  /// distance from obstacle (m)
  float up;
  /// Down sensor flag: 0 - not working, 1 - working
  uint8_t down_health;
  /// Front sensor flag: 0 - not working, 1 - working
  uint8_t front_health;
  /// Right sensor flag: 0 - not working, 1 - working
  uint8_t right_health;
  /// Back sensor flag: 0 - not working, 1 - working
  uint8_t back_health;
  /// Left sensor flag: 0 - not working, 1 - working
  uint8_t left_health;
  /// Up sensor health flag: 0 - not working, 1 - working
  uint8_t up_health;
  /// Reserved sensor health flag
  uint8_t reserved;
} psdk_interfaces__msg__RelativeObstacleInfo;

// Struct for a sequence of psdk_interfaces__msg__RelativeObstacleInfo.
typedef struct psdk_interfaces__msg__RelativeObstacleInfo__Sequence
{
  psdk_interfaces__msg__RelativeObstacleInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__RelativeObstacleInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__STRUCT_H_
