// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/RelativeObstacleInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__RelativeObstacleInfo __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__RelativeObstacleInfo __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RelativeObstacleInfo_
{
  using Type = RelativeObstacleInfo_<ContainerAllocator>;

  explicit RelativeObstacleInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->down = 0.0f;
      this->front = 0.0f;
      this->right = 0.0f;
      this->back = 0.0f;
      this->left = 0.0f;
      this->up = 0.0f;
      this->down_health = 0;
      this->front_health = 0;
      this->right_health = 0;
      this->back_health = 0;
      this->left_health = 0;
      this->up_health = 0;
      this->reserved = 0;
    }
  }

  explicit RelativeObstacleInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->down = 0.0f;
      this->front = 0.0f;
      this->right = 0.0f;
      this->back = 0.0f;
      this->left = 0.0f;
      this->up = 0.0f;
      this->down_health = 0;
      this->front_health = 0;
      this->right_health = 0;
      this->back_health = 0;
      this->left_health = 0;
      this->up_health = 0;
      this->reserved = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _down_type =
    float;
  _down_type down;
  using _front_type =
    float;
  _front_type front;
  using _right_type =
    float;
  _right_type right;
  using _back_type =
    float;
  _back_type back;
  using _left_type =
    float;
  _left_type left;
  using _up_type =
    float;
  _up_type up;
  using _down_health_type =
    uint8_t;
  _down_health_type down_health;
  using _front_health_type =
    uint8_t;
  _front_health_type front_health;
  using _right_health_type =
    uint8_t;
  _right_health_type right_health;
  using _back_health_type =
    uint8_t;
  _back_health_type back_health;
  using _left_health_type =
    uint8_t;
  _left_health_type left_health;
  using _up_health_type =
    uint8_t;
  _up_health_type up_health;
  using _reserved_type =
    uint8_t;
  _reserved_type reserved;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__down(
    const float & _arg)
  {
    this->down = _arg;
    return *this;
  }
  Type & set__front(
    const float & _arg)
  {
    this->front = _arg;
    return *this;
  }
  Type & set__right(
    const float & _arg)
  {
    this->right = _arg;
    return *this;
  }
  Type & set__back(
    const float & _arg)
  {
    this->back = _arg;
    return *this;
  }
  Type & set__left(
    const float & _arg)
  {
    this->left = _arg;
    return *this;
  }
  Type & set__up(
    const float & _arg)
  {
    this->up = _arg;
    return *this;
  }
  Type & set__down_health(
    const uint8_t & _arg)
  {
    this->down_health = _arg;
    return *this;
  }
  Type & set__front_health(
    const uint8_t & _arg)
  {
    this->front_health = _arg;
    return *this;
  }
  Type & set__right_health(
    const uint8_t & _arg)
  {
    this->right_health = _arg;
    return *this;
  }
  Type & set__back_health(
    const uint8_t & _arg)
  {
    this->back_health = _arg;
    return *this;
  }
  Type & set__left_health(
    const uint8_t & _arg)
  {
    this->left_health = _arg;
    return *this;
  }
  Type & set__up_health(
    const uint8_t & _arg)
  {
    this->up_health = _arg;
    return *this;
  }
  Type & set__reserved(
    const uint8_t & _arg)
  {
    this->reserved = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__RelativeObstacleInfo
    std::shared_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__RelativeObstacleInfo
    std::shared_ptr<psdk_interfaces::msg::RelativeObstacleInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RelativeObstacleInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->down != other.down) {
      return false;
    }
    if (this->front != other.front) {
      return false;
    }
    if (this->right != other.right) {
      return false;
    }
    if (this->back != other.back) {
      return false;
    }
    if (this->left != other.left) {
      return false;
    }
    if (this->up != other.up) {
      return false;
    }
    if (this->down_health != other.down_health) {
      return false;
    }
    if (this->front_health != other.front_health) {
      return false;
    }
    if (this->right_health != other.right_health) {
      return false;
    }
    if (this->back_health != other.back_health) {
      return false;
    }
    if (this->left_health != other.left_health) {
      return false;
    }
    if (this->up_health != other.up_health) {
      return false;
    }
    if (this->reserved != other.reserved) {
      return false;
    }
    return true;
  }
  bool operator!=(const RelativeObstacleInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RelativeObstacleInfo_

// alias to use template instance with default allocator
using RelativeObstacleInfo =
  psdk_interfaces::msg::RelativeObstacleInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__STRUCT_HPP_
