// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/SDKCtrlInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__SDK_CTRL_INFO__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__SDK_CTRL_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/sdk_ctrl_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const SDKCtrlInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: control_mode
  {
    out << "control_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.control_mode, out);
    out << ", ";
  }

  // member: device_status
  {
    out << "device_status: ";
    rosidl_generator_traits::value_to_yaml(msg.device_status, out);
    out << ", ";
  }

  // member: flight_status
  {
    out << "flight_status: ";
    rosidl_generator_traits::value_to_yaml(msg.flight_status, out);
    out << ", ";
  }

  // member: vrc_status
  {
    out << "vrc_status: ";
    rosidl_generator_traits::value_to_yaml(msg.vrc_status, out);
    out << ", ";
  }

  // member: reserved
  {
    out << "reserved: ";
    rosidl_generator_traits::value_to_yaml(msg.reserved, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SDKCtrlInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: control_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "control_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.control_mode, out);
    out << "\n";
  }

  // member: device_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_status: ";
    rosidl_generator_traits::value_to_yaml(msg.device_status, out);
    out << "\n";
  }

  // member: flight_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "flight_status: ";
    rosidl_generator_traits::value_to_yaml(msg.flight_status, out);
    out << "\n";
  }

  // member: vrc_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vrc_status: ";
    rosidl_generator_traits::value_to_yaml(msg.vrc_status, out);
    out << "\n";
  }

  // member: reserved
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reserved: ";
    rosidl_generator_traits::value_to_yaml(msg.reserved, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SDKCtrlInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::SDKCtrlInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::SDKCtrlInfo & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::SDKCtrlInfo>()
{
  return "psdk_interfaces::msg::SDKCtrlInfo";
}

template<>
inline const char * name<psdk_interfaces::msg::SDKCtrlInfo>()
{
  return "psdk_interfaces/msg/SDKCtrlInfo";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::SDKCtrlInfo>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::SDKCtrlInfo>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::SDKCtrlInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__SDK_CTRL_INFO__TRAITS_HPP_
