// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/SingleBatteryInfo.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/single_battery_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
psdk_interfaces__msg__SingleBatteryInfo__init(psdk_interfaces__msg__SingleBatteryInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__SingleBatteryInfo__fini(msg);
    return false;
  }
  // battery_index
  // voltage
  // current
  // full_capacity
  // capacity_remain
  // capacity_percentage
  // temperature
  // cell_count
  // self_check_error
  // closed_reason
  // abnormal_comm
  // is_embed
  return true;
}

void
psdk_interfaces__msg__SingleBatteryInfo__fini(psdk_interfaces__msg__SingleBatteryInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // battery_index
  // voltage
  // current
  // full_capacity
  // capacity_remain
  // capacity_percentage
  // temperature
  // cell_count
  // self_check_error
  // closed_reason
  // abnormal_comm
  // is_embed
}

bool
psdk_interfaces__msg__SingleBatteryInfo__are_equal(const psdk_interfaces__msg__SingleBatteryInfo * lhs, const psdk_interfaces__msg__SingleBatteryInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // battery_index
  if (lhs->battery_index != rhs->battery_index) {
    return false;
  }
  // voltage
  if (lhs->voltage != rhs->voltage) {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // full_capacity
  if (lhs->full_capacity != rhs->full_capacity) {
    return false;
  }
  // capacity_remain
  if (lhs->capacity_remain != rhs->capacity_remain) {
    return false;
  }
  // capacity_percentage
  if (lhs->capacity_percentage != rhs->capacity_percentage) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  // cell_count
  if (lhs->cell_count != rhs->cell_count) {
    return false;
  }
  // self_check_error
  if (lhs->self_check_error != rhs->self_check_error) {
    return false;
  }
  // closed_reason
  if (lhs->closed_reason != rhs->closed_reason) {
    return false;
  }
  // abnormal_comm
  if (lhs->abnormal_comm != rhs->abnormal_comm) {
    return false;
  }
  // is_embed
  if (lhs->is_embed != rhs->is_embed) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__SingleBatteryInfo__copy(
  const psdk_interfaces__msg__SingleBatteryInfo * input,
  psdk_interfaces__msg__SingleBatteryInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // battery_index
  output->battery_index = input->battery_index;
  // voltage
  output->voltage = input->voltage;
  // current
  output->current = input->current;
  // full_capacity
  output->full_capacity = input->full_capacity;
  // capacity_remain
  output->capacity_remain = input->capacity_remain;
  // capacity_percentage
  output->capacity_percentage = input->capacity_percentage;
  // temperature
  output->temperature = input->temperature;
  // cell_count
  output->cell_count = input->cell_count;
  // self_check_error
  output->self_check_error = input->self_check_error;
  // closed_reason
  output->closed_reason = input->closed_reason;
  // abnormal_comm
  output->abnormal_comm = input->abnormal_comm;
  // is_embed
  output->is_embed = input->is_embed;
  return true;
}

psdk_interfaces__msg__SingleBatteryInfo *
psdk_interfaces__msg__SingleBatteryInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SingleBatteryInfo * msg = (psdk_interfaces__msg__SingleBatteryInfo *)allocator.allocate(sizeof(psdk_interfaces__msg__SingleBatteryInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__SingleBatteryInfo));
  bool success = psdk_interfaces__msg__SingleBatteryInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__SingleBatteryInfo__destroy(psdk_interfaces__msg__SingleBatteryInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__SingleBatteryInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__SingleBatteryInfo__Sequence__init(psdk_interfaces__msg__SingleBatteryInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SingleBatteryInfo * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__SingleBatteryInfo *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__SingleBatteryInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__SingleBatteryInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__SingleBatteryInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__SingleBatteryInfo__Sequence__fini(psdk_interfaces__msg__SingleBatteryInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__SingleBatteryInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__SingleBatteryInfo__Sequence *
psdk_interfaces__msg__SingleBatteryInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SingleBatteryInfo__Sequence * array = (psdk_interfaces__msg__SingleBatteryInfo__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__SingleBatteryInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__SingleBatteryInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__SingleBatteryInfo__Sequence__destroy(psdk_interfaces__msg__SingleBatteryInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__SingleBatteryInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__SingleBatteryInfo__Sequence__are_equal(const psdk_interfaces__msg__SingleBatteryInfo__Sequence * lhs, const psdk_interfaces__msg__SingleBatteryInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__SingleBatteryInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__SingleBatteryInfo__Sequence__copy(
  const psdk_interfaces__msg__SingleBatteryInfo__Sequence * input,
  psdk_interfaces__msg__SingleBatteryInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__SingleBatteryInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__SingleBatteryInfo * data =
      (psdk_interfaces__msg__SingleBatteryInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__SingleBatteryInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__SingleBatteryInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__SingleBatteryInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
