// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/SingleBatteryInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__SINGLE_BATTERY_INFO__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__SINGLE_BATTERY_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__SingleBatteryInfo __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__SingleBatteryInfo __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SingleBatteryInfo_
{
  using Type = SingleBatteryInfo_<ContainerAllocator>;

  explicit SingleBatteryInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->battery_index = 0;
      this->voltage = 0.0f;
      this->current = 0.0f;
      this->full_capacity = 0.0f;
      this->capacity_remain = 0.0f;
      this->capacity_percentage = 0.0f;
      this->temperature = 0.0f;
      this->cell_count = 0;
      this->self_check_error = 0ul;
      this->closed_reason = 0ul;
      this->abnormal_comm = 0;
      this->is_embed = 0;
    }
  }

  explicit SingleBatteryInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->battery_index = 0;
      this->voltage = 0.0f;
      this->current = 0.0f;
      this->full_capacity = 0.0f;
      this->capacity_remain = 0.0f;
      this->capacity_percentage = 0.0f;
      this->temperature = 0.0f;
      this->cell_count = 0;
      this->self_check_error = 0ul;
      this->closed_reason = 0ul;
      this->abnormal_comm = 0;
      this->is_embed = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _battery_index_type =
    uint8_t;
  _battery_index_type battery_index;
  using _voltage_type =
    float;
  _voltage_type voltage;
  using _current_type =
    float;
  _current_type current;
  using _full_capacity_type =
    float;
  _full_capacity_type full_capacity;
  using _capacity_remain_type =
    float;
  _capacity_remain_type capacity_remain;
  using _capacity_percentage_type =
    float;
  _capacity_percentage_type capacity_percentage;
  using _temperature_type =
    float;
  _temperature_type temperature;
  using _cell_count_type =
    uint8_t;
  _cell_count_type cell_count;
  using _self_check_error_type =
    uint32_t;
  _self_check_error_type self_check_error;
  using _closed_reason_type =
    uint32_t;
  _closed_reason_type closed_reason;
  using _abnormal_comm_type =
    uint16_t;
  _abnormal_comm_type abnormal_comm;
  using _is_embed_type =
    uint16_t;
  _is_embed_type is_embed;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__battery_index(
    const uint8_t & _arg)
  {
    this->battery_index = _arg;
    return *this;
  }
  Type & set__voltage(
    const float & _arg)
  {
    this->voltage = _arg;
    return *this;
  }
  Type & set__current(
    const float & _arg)
  {
    this->current = _arg;
    return *this;
  }
  Type & set__full_capacity(
    const float & _arg)
  {
    this->full_capacity = _arg;
    return *this;
  }
  Type & set__capacity_remain(
    const float & _arg)
  {
    this->capacity_remain = _arg;
    return *this;
  }
  Type & set__capacity_percentage(
    const float & _arg)
  {
    this->capacity_percentage = _arg;
    return *this;
  }
  Type & set__temperature(
    const float & _arg)
  {
    this->temperature = _arg;
    return *this;
  }
  Type & set__cell_count(
    const uint8_t & _arg)
  {
    this->cell_count = _arg;
    return *this;
  }
  Type & set__self_check_error(
    const uint32_t & _arg)
  {
    this->self_check_error = _arg;
    return *this;
  }
  Type & set__closed_reason(
    const uint32_t & _arg)
  {
    this->closed_reason = _arg;
    return *this;
  }
  Type & set__abnormal_comm(
    const uint16_t & _arg)
  {
    this->abnormal_comm = _arg;
    return *this;
  }
  Type & set__is_embed(
    const uint16_t & _arg)
  {
    this->is_embed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__SingleBatteryInfo
    std::shared_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__SingleBatteryInfo
    std::shared_ptr<psdk_interfaces::msg::SingleBatteryInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SingleBatteryInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->battery_index != other.battery_index) {
      return false;
    }
    if (this->voltage != other.voltage) {
      return false;
    }
    if (this->current != other.current) {
      return false;
    }
    if (this->full_capacity != other.full_capacity) {
      return false;
    }
    if (this->capacity_remain != other.capacity_remain) {
      return false;
    }
    if (this->capacity_percentage != other.capacity_percentage) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    if (this->cell_count != other.cell_count) {
      return false;
    }
    if (this->self_check_error != other.self_check_error) {
      return false;
    }
    if (this->closed_reason != other.closed_reason) {
      return false;
    }
    if (this->abnormal_comm != other.abnormal_comm) {
      return false;
    }
    if (this->is_embed != other.is_embed) {
      return false;
    }
    return true;
  }
  bool operator!=(const SingleBatteryInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SingleBatteryInfo_

// alias to use template instance with default allocator
using SingleBatteryInfo =
  psdk_interfaces::msg::SingleBatteryInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__SINGLE_BATTERY_INFO__STRUCT_HPP_
