// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/SingleBatteryInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__SINGLE_BATTERY_INFO__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__SINGLE_BATTERY_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/single_battery_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const SingleBatteryInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: battery_index
  {
    out << "battery_index: ";
    rosidl_generator_traits::value_to_yaml(msg.battery_index, out);
    out << ", ";
  }

  // member: voltage
  {
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << ", ";
  }

  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: full_capacity
  {
    out << "full_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.full_capacity, out);
    out << ", ";
  }

  // member: capacity_remain
  {
    out << "capacity_remain: ";
    rosidl_generator_traits::value_to_yaml(msg.capacity_remain, out);
    out << ", ";
  }

  // member: capacity_percentage
  {
    out << "capacity_percentage: ";
    rosidl_generator_traits::value_to_yaml(msg.capacity_percentage, out);
    out << ", ";
  }

  // member: temperature
  {
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << ", ";
  }

  // member: cell_count
  {
    out << "cell_count: ";
    rosidl_generator_traits::value_to_yaml(msg.cell_count, out);
    out << ", ";
  }

  // member: self_check_error
  {
    out << "self_check_error: ";
    rosidl_generator_traits::value_to_yaml(msg.self_check_error, out);
    out << ", ";
  }

  // member: closed_reason
  {
    out << "closed_reason: ";
    rosidl_generator_traits::value_to_yaml(msg.closed_reason, out);
    out << ", ";
  }

  // member: abnormal_comm
  {
    out << "abnormal_comm: ";
    rosidl_generator_traits::value_to_yaml(msg.abnormal_comm, out);
    out << ", ";
  }

  // member: is_embed
  {
    out << "is_embed: ";
    rosidl_generator_traits::value_to_yaml(msg.is_embed, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SingleBatteryInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: battery_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "battery_index: ";
    rosidl_generator_traits::value_to_yaml(msg.battery_index, out);
    out << "\n";
  }

  // member: voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << "\n";
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: full_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "full_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.full_capacity, out);
    out << "\n";
  }

  // member: capacity_remain
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "capacity_remain: ";
    rosidl_generator_traits::value_to_yaml(msg.capacity_remain, out);
    out << "\n";
  }

  // member: capacity_percentage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "capacity_percentage: ";
    rosidl_generator_traits::value_to_yaml(msg.capacity_percentage, out);
    out << "\n";
  }

  // member: temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << "\n";
  }

  // member: cell_count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cell_count: ";
    rosidl_generator_traits::value_to_yaml(msg.cell_count, out);
    out << "\n";
  }

  // member: self_check_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "self_check_error: ";
    rosidl_generator_traits::value_to_yaml(msg.self_check_error, out);
    out << "\n";
  }

  // member: closed_reason
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "closed_reason: ";
    rosidl_generator_traits::value_to_yaml(msg.closed_reason, out);
    out << "\n";
  }

  // member: abnormal_comm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "abnormal_comm: ";
    rosidl_generator_traits::value_to_yaml(msg.abnormal_comm, out);
    out << "\n";
  }

  // member: is_embed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_embed: ";
    rosidl_generator_traits::value_to_yaml(msg.is_embed, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SingleBatteryInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::SingleBatteryInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::SingleBatteryInfo & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::SingleBatteryInfo>()
{
  return "psdk_interfaces::msg::SingleBatteryInfo";
}

template<>
inline const char * name<psdk_interfaces::msg::SingleBatteryInfo>()
{
  return "psdk_interfaces/msg/SingleBatteryInfo";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::SingleBatteryInfo>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::SingleBatteryInfo>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::SingleBatteryInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__SINGLE_BATTERY_INFO__TRAITS_HPP_
