// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/SubFileInfo.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/sub_file_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"
// Member `attributes`
#include "psdk_interfaces/msg/detail/file_attributes__functions.h"

bool
psdk_interfaces__msg__SubFileInfo__init(psdk_interfaces__msg__SubFileInfo * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    psdk_interfaces__msg__SubFileInfo__fini(msg);
    return false;
  }
  // type
  // size
  // index
  // create_time_unix
  // attributes
  if (!psdk_interfaces__msg__FileAttributes__init(&msg->attributes)) {
    psdk_interfaces__msg__SubFileInfo__fini(msg);
    return false;
  }
  return true;
}

void
psdk_interfaces__msg__SubFileInfo__fini(psdk_interfaces__msg__SubFileInfo * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // type
  // size
  // index
  // create_time_unix
  // attributes
  psdk_interfaces__msg__FileAttributes__fini(&msg->attributes);
}

bool
psdk_interfaces__msg__SubFileInfo__are_equal(const psdk_interfaces__msg__SubFileInfo * lhs, const psdk_interfaces__msg__SubFileInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // type
  if (lhs->type != rhs->type) {
    return false;
  }
  // size
  if (lhs->size != rhs->size) {
    return false;
  }
  // index
  if (lhs->index != rhs->index) {
    return false;
  }
  // create_time_unix
  if (lhs->create_time_unix != rhs->create_time_unix) {
    return false;
  }
  // attributes
  if (!psdk_interfaces__msg__FileAttributes__are_equal(
      &(lhs->attributes), &(rhs->attributes)))
  {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__SubFileInfo__copy(
  const psdk_interfaces__msg__SubFileInfo * input,
  psdk_interfaces__msg__SubFileInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // type
  output->type = input->type;
  // size
  output->size = input->size;
  // index
  output->index = input->index;
  // create_time_unix
  output->create_time_unix = input->create_time_unix;
  // attributes
  if (!psdk_interfaces__msg__FileAttributes__copy(
      &(input->attributes), &(output->attributes)))
  {
    return false;
  }
  return true;
}

psdk_interfaces__msg__SubFileInfo *
psdk_interfaces__msg__SubFileInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SubFileInfo * msg = (psdk_interfaces__msg__SubFileInfo *)allocator.allocate(sizeof(psdk_interfaces__msg__SubFileInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__SubFileInfo));
  bool success = psdk_interfaces__msg__SubFileInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__SubFileInfo__destroy(psdk_interfaces__msg__SubFileInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__SubFileInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__SubFileInfo__Sequence__init(psdk_interfaces__msg__SubFileInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SubFileInfo * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__SubFileInfo *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__SubFileInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__SubFileInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__SubFileInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__SubFileInfo__Sequence__fini(psdk_interfaces__msg__SubFileInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__SubFileInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__SubFileInfo__Sequence *
psdk_interfaces__msg__SubFileInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SubFileInfo__Sequence * array = (psdk_interfaces__msg__SubFileInfo__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__SubFileInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__SubFileInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__SubFileInfo__Sequence__destroy(psdk_interfaces__msg__SubFileInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__SubFileInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__SubFileInfo__Sequence__are_equal(const psdk_interfaces__msg__SubFileInfo__Sequence * lhs, const psdk_interfaces__msg__SubFileInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__SubFileInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__SubFileInfo__Sequence__copy(
  const psdk_interfaces__msg__SubFileInfo__Sequence * input,
  psdk_interfaces__msg__SubFileInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__SubFileInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__SubFileInfo * data =
      (psdk_interfaces__msg__SubFileInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__SubFileInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__SubFileInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__SubFileInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
