// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:srv/CameraGetFocusMode.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FOCUS_MODE__TRAITS_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FOCUS_MODE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/srv/detail/camera_get_focus_mode__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraGetFocusMode_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: payload_index
  {
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraGetFocusMode_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: payload_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraGetFocusMode_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::CameraGetFocusMode_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::CameraGetFocusMode_Request & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetFocusMode_Request>()
{
  return "psdk_interfaces::srv::CameraGetFocusMode_Request";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetFocusMode_Request>()
{
  return "psdk_interfaces/srv/CameraGetFocusMode_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetFocusMode_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetFocusMode_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::CameraGetFocusMode_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraGetFocusMode_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: focus_mode
  {
    out << "focus_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.focus_mode, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraGetFocusMode_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: focus_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "focus_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.focus_mode, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraGetFocusMode_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::CameraGetFocusMode_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::CameraGetFocusMode_Response & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetFocusMode_Response>()
{
  return "psdk_interfaces::srv::CameraGetFocusMode_Response";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetFocusMode_Response>()
{
  return "psdk_interfaces/srv/CameraGetFocusMode_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetFocusMode_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetFocusMode_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::CameraGetFocusMode_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetFocusMode>()
{
  return "psdk_interfaces::srv::CameraGetFocusMode";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetFocusMode>()
{
  return "psdk_interfaces/srv/CameraGetFocusMode";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetFocusMode>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::srv::CameraGetFocusMode_Request>::value &&
    has_fixed_size<psdk_interfaces::srv::CameraGetFocusMode_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetFocusMode>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::srv::CameraGetFocusMode_Request>::value &&
    has_bounded_size<psdk_interfaces::srv::CameraGetFocusMode_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::srv::CameraGetFocusMode>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::srv::CameraGetFocusMode_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::srv::CameraGetFocusMode_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_FOCUS_MODE__TRAITS_HPP_
