// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from psdk_interfaces:srv/CameraGetLaserRangingInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__BUILDER_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "psdk_interfaces/srv/detail/camera_get_laser_ranging_info__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace psdk_interfaces
{

namespace srv
{

namespace builder
{

class Init_CameraGetLaserRangingInfo_Request_payload_index
{
public:
  Init_CameraGetLaserRangingInfo_Request_payload_index()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Request payload_index(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Request::_payload_index_type arg)
  {
    msg_.payload_index = std::move(arg);
    return std::move(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>()
{
  return psdk_interfaces::srv::builder::Init_CameraGetLaserRangingInfo_Request_payload_index();
}

}  // namespace psdk_interfaces


namespace psdk_interfaces
{

namespace srv
{

namespace builder
{

class Init_CameraGetLaserRangingInfo_Response_exception
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_exception(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response exception(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_exception_type arg)
  {
    msg_.exception = std::move(arg);
    return std::move(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_enable_lidar
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_enable_lidar(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_exception enable_lidar(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_enable_lidar_type arg)
  {
    msg_.enable_lidar = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_exception(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_screen_y
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_screen_y(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_enable_lidar screen_y(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_screen_y_type arg)
  {
    msg_.screen_y = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_enable_lidar(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_screen_x
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_screen_x(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_screen_y screen_x(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_screen_x_type arg)
  {
    msg_.screen_x = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_screen_y(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_distance
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_distance(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_screen_x distance(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_distance_type arg)
  {
    msg_.distance = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_screen_x(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_altitude
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_altitude(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_distance altitude(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_altitude_type arg)
  {
    msg_.altitude = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_distance(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_latitude
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_latitude(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_altitude latitude(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_latitude_type arg)
  {
    msg_.latitude = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_altitude(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_longitude
{
public:
  explicit Init_CameraGetLaserRangingInfo_Response_longitude(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
  : msg_(msg)
  {}
  Init_CameraGetLaserRangingInfo_Response_latitude longitude(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_longitude_type arg)
  {
    msg_.longitude = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_latitude(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

class Init_CameraGetLaserRangingInfo_Response_success
{
public:
  Init_CameraGetLaserRangingInfo_Response_success()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_CameraGetLaserRangingInfo_Response_longitude success(::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response::_success_type arg)
  {
    msg_.success = std::move(arg);
    return Init_CameraGetLaserRangingInfo_Response_longitude(msg_);
  }

private:
  ::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>()
{
  return psdk_interfaces::srv::builder::Init_CameraGetLaserRangingInfo_Response_success();
}

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__BUILDER_HPP_
