// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:srv/CameraGetLaserRangingInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__TRAITS_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/srv/detail/camera_get_laser_ranging_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraGetLaserRangingInfo_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: payload_index
  {
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraGetLaserRangingInfo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: payload_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraGetLaserRangingInfo_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::CameraGetLaserRangingInfo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::CameraGetLaserRangingInfo_Request & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>()
{
  return "psdk_interfaces::srv::CameraGetLaserRangingInfo_Request";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>()
{
  return "psdk_interfaces/srv/CameraGetLaserRangingInfo_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraGetLaserRangingInfo_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: longitude
  {
    out << "longitude: ";
    rosidl_generator_traits::value_to_yaml(msg.longitude, out);
    out << ", ";
  }

  // member: latitude
  {
    out << "latitude: ";
    rosidl_generator_traits::value_to_yaml(msg.latitude, out);
    out << ", ";
  }

  // member: altitude
  {
    out << "altitude: ";
    rosidl_generator_traits::value_to_yaml(msg.altitude, out);
    out << ", ";
  }

  // member: distance
  {
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << ", ";
  }

  // member: screen_x
  {
    out << "screen_x: ";
    rosidl_generator_traits::value_to_yaml(msg.screen_x, out);
    out << ", ";
  }

  // member: screen_y
  {
    out << "screen_y: ";
    rosidl_generator_traits::value_to_yaml(msg.screen_y, out);
    out << ", ";
  }

  // member: enable_lidar
  {
    out << "enable_lidar: ";
    rosidl_generator_traits::value_to_yaml(msg.enable_lidar, out);
    out << ", ";
  }

  // member: exception
  {
    out << "exception: ";
    rosidl_generator_traits::value_to_yaml(msg.exception, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraGetLaserRangingInfo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: longitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longitude: ";
    rosidl_generator_traits::value_to_yaml(msg.longitude, out);
    out << "\n";
  }

  // member: latitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "latitude: ";
    rosidl_generator_traits::value_to_yaml(msg.latitude, out);
    out << "\n";
  }

  // member: altitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "altitude: ";
    rosidl_generator_traits::value_to_yaml(msg.altitude, out);
    out << "\n";
  }

  // member: distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << "\n";
  }

  // member: screen_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "screen_x: ";
    rosidl_generator_traits::value_to_yaml(msg.screen_x, out);
    out << "\n";
  }

  // member: screen_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "screen_y: ";
    rosidl_generator_traits::value_to_yaml(msg.screen_y, out);
    out << "\n";
  }

  // member: enable_lidar
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enable_lidar: ";
    rosidl_generator_traits::value_to_yaml(msg.enable_lidar, out);
    out << "\n";
  }

  // member: exception
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exception: ";
    rosidl_generator_traits::value_to_yaml(msg.exception, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraGetLaserRangingInfo_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::CameraGetLaserRangingInfo_Response & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>()
{
  return "psdk_interfaces::srv::CameraGetLaserRangingInfo_Response";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>()
{
  return "psdk_interfaces/srv/CameraGetLaserRangingInfo_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::srv::CameraGetLaserRangingInfo>()
{
  return "psdk_interfaces::srv::CameraGetLaserRangingInfo";
}

template<>
inline const char * name<psdk_interfaces::srv::CameraGetLaserRangingInfo>()
{
  return "psdk_interfaces/srv/CameraGetLaserRangingInfo";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::CameraGetLaserRangingInfo>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>::value &&
    has_fixed_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::srv::CameraGetLaserRangingInfo>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>::value &&
    has_bounded_size<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::srv::CameraGetLaserRangingInfo>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::srv::CameraGetLaserRangingInfo_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::srv::CameraGetLaserRangingInfo_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_GET_LASER_RANGING_INFO__TRAITS_HPP_
