// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:srv/CameraSetFocusTarget.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/srv/detail/camera_set_focus_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
psdk_interfaces__srv__CameraSetFocusTarget_Request__init(psdk_interfaces__srv__CameraSetFocusTarget_Request * msg)
{
  if (!msg) {
    return false;
  }
  // payload_index
  msg->payload_index = 1;
  // x_target
  // y_target
  return true;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Request__fini(psdk_interfaces__srv__CameraSetFocusTarget_Request * msg)
{
  if (!msg) {
    return;
  }
  // payload_index
  // x_target
  // y_target
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Request__are_equal(const psdk_interfaces__srv__CameraSetFocusTarget_Request * lhs, const psdk_interfaces__srv__CameraSetFocusTarget_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // payload_index
  if (lhs->payload_index != rhs->payload_index) {
    return false;
  }
  // x_target
  if (lhs->x_target != rhs->x_target) {
    return false;
  }
  // y_target
  if (lhs->y_target != rhs->y_target) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Request__copy(
  const psdk_interfaces__srv__CameraSetFocusTarget_Request * input,
  psdk_interfaces__srv__CameraSetFocusTarget_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // payload_index
  output->payload_index = input->payload_index;
  // x_target
  output->x_target = input->x_target;
  // y_target
  output->y_target = input->y_target;
  return true;
}

psdk_interfaces__srv__CameraSetFocusTarget_Request *
psdk_interfaces__srv__CameraSetFocusTarget_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__srv__CameraSetFocusTarget_Request * msg = (psdk_interfaces__srv__CameraSetFocusTarget_Request *)allocator.allocate(sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Request));
  bool success = psdk_interfaces__srv__CameraSetFocusTarget_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Request__destroy(psdk_interfaces__srv__CameraSetFocusTarget_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__srv__CameraSetFocusTarget_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__init(psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__srv__CameraSetFocusTarget_Request * data = NULL;

  if (size) {
    data = (psdk_interfaces__srv__CameraSetFocusTarget_Request *)allocator.zero_allocate(size, sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__srv__CameraSetFocusTarget_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__srv__CameraSetFocusTarget_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__fini(psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__srv__CameraSetFocusTarget_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence *
psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * array = (psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence *)allocator.allocate(sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__destroy(psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__are_equal(const psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * lhs, const psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__srv__CameraSetFocusTarget_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence__copy(
  const psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * input,
  psdk_interfaces__srv__CameraSetFocusTarget_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__srv__CameraSetFocusTarget_Request * data =
      (psdk_interfaces__srv__CameraSetFocusTarget_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__srv__CameraSetFocusTarget_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__srv__CameraSetFocusTarget_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__srv__CameraSetFocusTarget_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
psdk_interfaces__srv__CameraSetFocusTarget_Response__init(psdk_interfaces__srv__CameraSetFocusTarget_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Response__fini(psdk_interfaces__srv__CameraSetFocusTarget_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Response__are_equal(const psdk_interfaces__srv__CameraSetFocusTarget_Response * lhs, const psdk_interfaces__srv__CameraSetFocusTarget_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Response__copy(
  const psdk_interfaces__srv__CameraSetFocusTarget_Response * input,
  psdk_interfaces__srv__CameraSetFocusTarget_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  return true;
}

psdk_interfaces__srv__CameraSetFocusTarget_Response *
psdk_interfaces__srv__CameraSetFocusTarget_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__srv__CameraSetFocusTarget_Response * msg = (psdk_interfaces__srv__CameraSetFocusTarget_Response *)allocator.allocate(sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Response));
  bool success = psdk_interfaces__srv__CameraSetFocusTarget_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Response__destroy(psdk_interfaces__srv__CameraSetFocusTarget_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__srv__CameraSetFocusTarget_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__init(psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__srv__CameraSetFocusTarget_Response * data = NULL;

  if (size) {
    data = (psdk_interfaces__srv__CameraSetFocusTarget_Response *)allocator.zero_allocate(size, sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__srv__CameraSetFocusTarget_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__srv__CameraSetFocusTarget_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__fini(psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__srv__CameraSetFocusTarget_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence *
psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * array = (psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence *)allocator.allocate(sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__destroy(psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__are_equal(const psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * lhs, const psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__srv__CameraSetFocusTarget_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence__copy(
  const psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * input,
  psdk_interfaces__srv__CameraSetFocusTarget_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__srv__CameraSetFocusTarget_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__srv__CameraSetFocusTarget_Response * data =
      (psdk_interfaces__srv__CameraSetFocusTarget_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__srv__CameraSetFocusTarget_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__srv__CameraSetFocusTarget_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__srv__CameraSetFocusTarget_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
